/* -------------------------------------------------------------------------- */
			    /* Definice konstant */
/* -------------------------------------------------------------------------- */

#define MAX_DELKA_RETEZCE	60		/* pro Scrabble sta 15 */
#define MAX_VELIKOST_ABECEDY	256		/* monost a 256 vtv */ 
#define MAX_POCET_PRECHODU	1048576
#define MAX_POCET_STAVU         524288

#define VELIKOST_HASH_TABULKY	1048576		/* celkov poet poloek */
#define VELIKOST_HASH_POLOZKY	1024            /* velikost koliznho seznamu */


/* -------------------------------------------------------------------------- */
		   /* Definice prechodu - 32bitov hodnota */
/* -------------------------------------------------------------------------- */

typedef union {
    unsigned int cis_hodnota;       /* = 32b slo */
    struct {
	unsigned int posledni :  1; /*  1 bit  - posledni pechod ze stavu*/
	unsigned int do_stavu : 22; /* 22 bit - stavy */
	unsigned int znak     :  8; /*  8 bit - znak */
        unsigned int terminal :  1; /*  1 bit  - koncov pechod */
				    /* -------------- */
			            /* 32 bit celkem */ 			    
    } t;
} prechod;

/* Union zajist, e pi pstupu k pechodu vidm buto jednotliv poloky
 * nebo jednu selnou hodnotu z nich tvoenou.
*/

/* -------------------------------------------------------------------------- */
		    /* Definice poloky haovac tabulky */
/* -------------------------------------------------------------------------- */


typedef struct hpolozka
{
    unsigned int adresa;	/* ukazatel na pozici stavu v automatu */
    unsigned int velikost;	/* jeho velikost */
    struct hpolozka *naslednik; /* nslednk v koliznm seznamu */
    
} polozka;

typedef unsigned int Stav;      /* Obsahuje pechody */
typedef prechod Prechod;	/* A stavy */

typedef struct {
    int n;                              /* Dlka */
    unsigned char c[MAX_ROZMER];        /* Jednotliv znaky */
} Slovo;


/* -------------------------------------------------------------------------- */
			    /* Globln promnn */
/* -------------------------------------------------------------------------- */

EXPORT unsigned int velikost_automatu;		/* celkov poet pechod */
EXPORT unsigned int pocatecni_stav;             /* jeho pozice v automatu */
EXPORT Stav koren;				/* automat[0].cis_hodnota */
EXPORT Prechod automat[MAX_POCET_PRECHODU];     /* pole pechod */

/* -------------------------------------------------------------------------- */
			     /* Globln funkce */
/* -------------------------------------------------------------------------- */

EXPORT void nacti_automat(char *cesta);
EXPORT void uloz_automat(void);
EXPORT int testuj_retezec(unsigned char *retezec);
EXPORT void vypis_retezce(unsigned int pozice, int ret_poz, FILE *soubor);
EXPORT Stav traverzuj(Stav n, Slovo *w, int kolik);
EXPORT boolean je_slovo(Stav start, Slovo *w);

/* END_OF_FILE automat.h */
