#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<sys/stat.h>
#include<sys/types.h>
#include<glib.h>
#include<gdk/gdk.h>
#include<libgnome/gnome-defs.h>
#include<libgnome/gnome-config.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "slovniky.h"
#include "config.h"
#include "cesty.h"
#include "util.h"

/* Soubor s definicemi vech monch nastaven - velikosti kamen, poty
 * psmen, jejich hodnoty, nastaven font, velikost okna, barvy pol...
*/

/* -------------------------- LOKLN PROMNN ------------------------------ */
    
LOCAL GdkFont *testfont;	/* Budeme testovat existenci font */

/* -------------------------- GLOBLN PROMNN ----------------------------- */

GLOBAL char slovmult[MAX_ROZMER][MAX_ROZMER];	/* Pole se slovnmi bonusy */
GLOBAL char pismmult[MAX_ROZMER][MAX_ROZMER];	/* Pole s psmennmi bonusy */

GLOBAL tpreference akt;		/* Aktuln naten nastaven */
GLOBAL tpreference nov;		/* Nastaven proveden v Konfiguraci */

/* fonty pro hrac kameny a hrac plochu */
GLOBAL char KAMEN_FONT[DMAX];
GLOBAL char HODNOTA_FONT[DMAX];
GLOBAL char POPIS_FONT[DMAX];
GLOBAL char BONUS_FONT[DMAX];

GLOBAL char ZAKAZANA_SOUBOR[DMAX];

GLOBAL char LOGOVANI_SOUBOR[DMAX];

/* definice rozmr desky, okna, kamene, pihrdky,... */

GLOBAL int MAX_PISMEN_PRIHRADKA;
GLOBAL int POC_KAMENU_SIRKA;		/* rozmry desky */
GLOBAL int POC_KAMENU_VYSKA; 
 
GLOBAL int VEL_OKNO_SIRKA;		/* v bodech */
GLOBAL int VEL_OKNO_VYSKA;
GLOBAL int VEL_KAMENE;			

GLOBAL int VEL_BONUS_POLE;
GLOBAL int VEL_CANVAS_SIRKA;
GLOBAL int VEL_CANVAS_VYSKA;
GLOBAL int VEL_DESKA_SIRKA;
GLOBAL int VEL_DESKA_VYSKA;
GLOBAL int VEL_RACK_SIRKA;
GLOBAL int VEL_RACK_VYSKA;
GLOBAL int VEL_OKRAJ_DESKY;

/* Vlastnosti grafickch prvk */
GLOBAL int HOFFX;      /* x-offset hodnoty */
GLOBAL int HOFFY;      /* y-offset hodnoty */
GLOBAL int POFFX;      /* x-offset psmene 19 */
GLOBAL int POFFY;      /* y-offset psmene 18 */

/* Definice barevnch konstant */
GLOBAL unsigned int white_clr;
GLOBAL unsigned int black_clr;
GLOBAL unsigned int red_clr;
GLOBAL unsigned int cyan_clr;
GLOBAL unsigned int blue_clr;
GLOBAL unsigned int pink_clr;
GLOBAL unsigned int green_clr;
GLOBAL unsigned int yellow_clr;
GLOBAL unsigned int gray_clr = 0xEEEEEEFF;

/* Definice text bonusovch polek a jin*/

GLOBAL int SLOVOX2;
GLOBAL int SLOVOX3;
GLOBAL int PISMX2;
GLOBAL int PISMX3;

LOCAL char SLOVO2POLE[DMAX];
LOCAL char SLOVO3POLE[DMAX];
LOCAL char PISMENO2POLE[DMAX];
LOCAL char PISMENO3POLE[DMAX];

/* Sada kamen */
GLOBAL char SADA_PISMEN[2*DMAX];

/* Cesty ke slovnikm */
LOCAL char SLOVNIKY[10*DMAX];

/* Parametr urujc, zda se pi 'Pout' bude zobrazovat
 * okno s informac o 'zmnch a po restartu'
*/
GLOBAL boolean zobr_info;

/* Zda pouvat seznam zakzanch slov */
GLOBAL boolean pouzit_zakazana;

/* Zda se bude logovat prbh hry */
GLOBAL int logovat_prubeh = 0;

/* Obtnost */
GLOBAL int obtiznost_hry = 2;

/* -------------- PLN FUNKN PROTOTYPY GLOBLNCH FUNKC ----------------- */

GLOBAL void config_nacti_nastaveni(void);
GLOBAL void config_uloz_nastaveni(tpreference *p);

/* -------------- PLN FUNKN PROTOTYPY LOCLNCH FUNKC ------------------ */

LOCAL void config_resetuj_matice_bonusu(void); 
LOCAL void config_uloz_defaults(void);
#ifdef CONF_DEBUG
LOCAL void config_zobraz_nastaveni(void);
#endif
LOCAL void config_napln_matici_bonusu(char *souradnice, int hodnota, int co);
LOCAL void config_napln_seznam_slovniku(char *tseznam);
LOCAL void config_napln_nastaveni(void);
LOCAL void config_otestuj_font(char *font);
LOCAL void config_font_nelze_nahrat(char *font);

/* --------------------- DEFINICE GLOBLNCH FUNKC ------------------------- */

/* Nate nastaven z konfiguranho souboru 
 * (obvykle ~/.gnome/scarabeus) a ulo do pslunch promnnch a 
 * 'nastaven'.
*/
GLOBAL void config_nacti_nastaveni(void) {

    char *ukazatel;
    char *home;

#ifdef CONF_DEBUG
    int i, j;
#endif

    home = getenv("HOME");
    ukazatel = g_strconcat(home, "/.scarabeus", NULL);

    if ( util_soubor_existuje(ukazatel) == FALSE )
	mkdir(ukazatel, 493);

    g_free((gpointer) ukazatel);
	
    gnome_config_push_prefix(DeskaPrefix);
    
    POC_KAMENU_SIRKA = gnome_config_get_int("POC_KAMENU_SIRKA");

    /* Neexistuje-li konfig. soubor, vytvo defaultn */
    if (!POC_KAMENU_SIRKA) 
	config_uloz_defaults();

    gnome_config_pop_prefix();

    /* fonty pro hrac kameny a hrac plochu */
    gnome_config_push_prefix(FontyPrefix);
    
    ukazatel = gnome_config_get_string("KAMEN_FONT=-adobe-times-bold-r-normal--20-*-*-*-*-*-iso8859-2");
    strcpy(KAMEN_FONT, ukazatel);
    g_free((gpointer)ukazatel);
    config_otestuj_font(KAMEN_FONT);
    
    ukazatel = gnome_config_get_string("HODNOTA_FONT=-adobe-times-bold-r-normal--10-*-*-*-*-*-iso8859-2");
    strcpy(HODNOTA_FONT, ukazatel);
    g_free((gpointer)ukazatel);
    config_otestuj_font(HODNOTA_FONT);
    
    ukazatel = gnome_config_get_string("POPIS_FONT=-adobe-times-bold-r-normal--12-*-*-*-*-*-iso8859-2");
    strcpy(POPIS_FONT, ukazatel);
    g_free((gpointer)ukazatel);
    config_otestuj_font(POPIS_FONT);
   
    ukazatel = gnome_config_get_string("BONUS_FONT=-*-helvetica-bold-r-normal--12-*-*-*-*-*-iso8859-2");
    strcpy(BONUS_FONT, ukazatel);
    g_free((gpointer)ukazatel);
    config_otestuj_font(BONUS_FONT);
    
    gnome_config_pop_prefix();
    
    /* definice rozmr desky, okna, kamene, pihrdky,... */
    gnome_config_push_prefix(DeskaPrefix);
    
    MAX_PISMEN_PRIHRADKA = gnome_config_get_int("MAX_PISMEN_PRIHRADKA=7");

    POC_KAMENU_SIRKA = gnome_config_get_int("POC_KAMENU_SIRKA=15");

    POC_KAMENU_VYSKA  = gnome_config_get_int("POC_KAMENU_VYSKA=15");

    VEL_KAMENE = gnome_config_get_int("VEL_KAMENE=32");

    HOFFX = (VEL_KAMENE/4);       /* x-offset hodnoty */
    HOFFY = (VEL_KAMENE/4);       /* y-offset hodnoty */
    POFFX = ((VEL_KAMENE/2)+3);   /* x-offset psmene 19 */
    POFFY = ((VEL_KAMENE/2)+2);   /* y-offset psmene 18 */

    VEL_OKRAJ_DESKY = VEL_KAMENE;
    VEL_BONUS_POLE = (VEL_KAMENE/2);
    VEL_CANVAS_SIRKA = (POC_KAMENU_SIRKA*VEL_KAMENE)+2*VEL_OKRAJ_DESKY;
    VEL_CANVAS_VYSKA = (POC_KAMENU_VYSKA*VEL_KAMENE)+2*VEL_OKRAJ_DESKY;
    VEL_DESKA_SIRKA = POC_KAMENU_SIRKA*VEL_KAMENE;
    VEL_DESKA_VYSKA = POC_KAMENU_VYSKA*VEL_KAMENE;
    VEL_RACK_SIRKA = (MAX_PISMEN_PRIHRADKA)*VEL_KAMENE+2; 
    VEL_RACK_VYSKA = VEL_KAMENE+2;
    
    VEL_OKNO_SIRKA = VEL_CANVAS_SIRKA + 500;
    VEL_OKNO_VYSKA = VEL_CANVAS_VYSKA + 5*VEL_KAMENE + VEL_RACK_VYSKA;
    
    gnome_config_pop_prefix();
    
    /* Definice barevnch konstant */
    gnome_config_push_prefix(BarvyPrefix);
    
    white_clr = 0xFFFFFFFF;

    black_clr = 0x000000FF;

    red_clr = gnome_config_get_int("BARVA5=-378464257");

    cyan_clr = gnome_config_get_int("BARVA2=-1512574977");

    blue_clr = gnome_config_get_int("BARVA3=11853823");

    pink_clr = gnome_config_get_int("BARVA4=-138705921");

    green_clr = gnome_config_get_int("BARVA1=1539123711");

    yellow_clr = 0xFFFFC0FF;


    gnome_config_pop_prefix();

    /* Definice bonusovch polek a jin*/
    gnome_config_push_prefix(KamenyPrefix);
    
    SLOVOX2 = gnome_config_get_int("SLOVOX2=2");

    SLOVOX3 = gnome_config_get_int("SLOVOX3=3");

    PISMX2 = gnome_config_get_int("PISMX2=2");

    PISMX3 = gnome_config_get_int("PISMX3=3");

    ukazatel = gnome_config_get_string("SLOVO2POLE=2,2;2,14;3,3;3,13;4,4;4,12;5,5;5,11;8,8;11,5;11,11;12,4;12,12;13,3;13,13;14,2;14,14;");
    strcpy(SLOVO2POLE, ukazatel);
    g_free((gpointer)ukazatel);

    /* Vytvome matici bonusovch pol */ 
    config_resetuj_matice_bonusu(); 

    /* Napl slovmult (=0) nebo pismmult (=1) (3. parametr) */
    config_napln_matici_bonusu(SLOVO2POLE, SLOVOX2, 1);
    
    ukazatel = gnome_config_get_string("SLOVO3POLE=1,1;1,8;1,15;8,1;8,15;15,1;15,8;15,15;");
    strcpy(SLOVO3POLE, ukazatel);
    g_free((gpointer)ukazatel);
    
    config_napln_matici_bonusu(SLOVO3POLE, SLOVOX3, 1);
    
    ukazatel = gnome_config_get_string("PISMENO2POLE=1,4;1,12;3,7;3,9;4,1;4,8;4,15;7,3;7,7;7,9;7,13;8,4;8,12;9,3;9,7;9,9;9,13;12,1;12,8;12,15;13,7;13,9;15,4;15,12;");
    strcpy(PISMENO2POLE, ukazatel);
    g_free((gpointer)ukazatel);
    
    config_napln_matici_bonusu(PISMENO2POLE, PISMX2, 0);
    
    ukazatel = gnome_config_get_string("PISMENO3POLE=2,6;2,10;6,2;6,6;6,10;6,14;10,2;10,6;10,10;10,14;14,6;14,10;");
    strcpy(PISMENO3POLE, ukazatel);
    g_free((gpointer)ukazatel);
    
    config_napln_matici_bonusu(PISMENO3POLE, PISMX3, 0);
    
    ukazatel = gnome_config_get_string("SADA_PISMEN=a,1,5;,2,2;b,3,2;c,2,3;,4,1;d,1,3;,8,1;e,1,5;,3,2;,3,2;f,5,1;g,5,1;h,2,3;i,1,4;,2,3;j,2,2;k,1,3;l,1,3;m,2,3;n,1,5;,6,1;o,1,6;,7,1;p,1,3;r,1,3;,4,2;s,1,4;,4,2;t,1,4;,7,1;u,2,3;,5,1;,4,1;v,1,4;x,10,1;y,2,2;,4,2;z,2,2;,4,1;");
    strcpy(SADA_PISMEN, ukazatel);
    g_free((gpointer)ukazatel);

    gnome_config_pop_prefix();

    /* Cesty k externm slovnkm */
    gnome_config_push_prefix(SlovnikyPrefix);

    ukazatel = gnome_config_get_string("SLOVNIKY=");
    strcpy(SLOVNIKY, ukazatel);
    g_free((gpointer)ukazatel); 
   
    /* Vytvo spojov seznam vech cest k externm slovnkm */ 
    config_napln_seznam_slovniku(SLOVNIKY);

    gnome_config_pop_prefix();
    
    /* Gui volby */
    gnome_config_push_prefix(GuiPrefix);

    zobr_info = gnome_config_get_int("VIEW_INFO=1");
    
    ukazatel = gnome_config_get_string("ZAKAZANA_SOUBOR=scarabeus.scz");
    /* Vytvome cestu /home/user/.scarabeus/ZAKAZANA_SOUBOR */
    home = getenv("HOME");
    strcpy(ZAKAZANA_SOUBOR, home);
    strcat(ZAKAZANA_SOUBOR, "/.scarabeus/");
    strcat(ZAKAZANA_SOUBOR, ukazatel);
    g_free((gpointer)ukazatel); 

    pouzit_zakazana = gnome_config_get_int("POUZIT_ZAKAZANA=0");

    logovat_prubeh = gnome_config_get_int("LOGOVAT_PRUBEH=0");

    /* scarabeus.log se pouije pouze v ppad, je-li promnn
     * 'logovat_prubeh == TRUE' a LOGOVANI_SOUBOR je przdn.
    */
    ukazatel = gnome_config_get_string("LOGOVANI_SOUBOR=scarabeus.log");

    /* == 1 Byl vybrn soubor */
    if (logovat_prubeh == 1) {
	/* Vytvome cestu /home/user/.scarabeus/LOGOVANI_SOUBOR */
	strcpy(LOGOVANI_SOUBOR, home);
	strcat(LOGOVANI_SOUBOR, "/.scarabeus/");
	strcat(LOGOVANI_SOUBOR, ukazatel);
    }
    g_free((gpointer)ukazatel);

    gnome_config_pop_prefix();
    
    gnome_config_drop_all();


#ifdef CONF_DEBUG

    config_zobraz_nastaveni();

    for(i=0;i<=POC_KAMENU_SIRKA+1;i++) {
	for(j=0;j<=POC_KAMENU_VYSKA+1;j++)
	    printf("%d", slovmult[i][j]);
	printf("\n");
    }
    printf("\n\n");
    for(i=0;i<=POC_KAMENU_SIRKA+1;i++) {
	for(j=0;j<=POC_KAMENU_VYSKA+1;j++)
	    printf("%d", pismmult[i][j]);
	printf("\n");
    }
#endif

    config_napln_nastaveni();    	/* Napl promnn s nastavenmi */

}/* end of config_nacti_nastaveni() */

/* -------------------------------------------------------------------------- */

/* Ulo aktuln hodnoty konfiguranch nastaven */
GLOBAL void config_uloz_nastaveni(tpreference *p) {

    /* definice font */
    gnome_config_push_prefix(FontyPrefix);

    gnome_config_set_string("KAMEN_FONT", p->KAMEN_FONT);
    gnome_config_set_string("HODNOTA_FONT", p->HODNOTA_FONT);
    gnome_config_set_string("POPIS_FONT", p->POPIS_FONT);
    gnome_config_set_string("BONUS_FONT", p->BONUS_FONT);

    gnome_config_pop_prefix();

    /* definice rozmr desky, okna, kamene, pihrdky,... */
    gnome_config_push_prefix(DeskaPrefix);

    gnome_config_set_int("MAX_PISMEN_PRIHRADKA", p->MAX_PISMEN_PRIHRADKA);
    gnome_config_set_int("POC_KAMENU_SIRKA", p->POC_KAMENU_SIRKA);
    gnome_config_set_int("POC_KAMENU_VYSKA", p->POC_KAMENU_VYSKA); 
    gnome_config_set_int("VEL_KAMENE", p->VEL_KAMENE);

    gnome_config_pop_prefix();
    
    /* Definice barevnch konstant */
    gnome_config_push_prefix(BarvyPrefix);
    
    gnome_config_set_int("BARVA1", p->BARVA1);
    gnome_config_set_int("BARVA2", p->BARVA2);
    gnome_config_set_int("BARVA3", p->BARVA3);
    gnome_config_set_int("BARVA4", p->BARVA4);
    gnome_config_set_int("BARVA5", p->BARVA5);
    
    gnome_config_pop_prefix();
    
    /* Definice bonusovch polek a jin*/
    gnome_config_push_prefix(KamenyPrefix);

    gnome_config_set_int("SLOVOX2", p->SLOVOX2);
    gnome_config_set_int("SLOVOX3", p->SLOVOX3);
    gnome_config_set_int("PISMX2", p->PISMX2);
    gnome_config_set_int("PISMX3", p->PISMX3);

    gnome_config_set_string("SLOVO2POLE", p->SLOVO2POLE);
    gnome_config_set_string("SLOVO3POLE", p->SLOVO3POLE);
    gnome_config_set_string("PISMENO2POLE", p->PISMENO2POLE);
    gnome_config_set_string("PISMENO3POLE", p->PISMENO3POLE);
    gnome_config_set_string("SADA_PISMEN", p->SADA_PISMEN);
    
    gnome_config_pop_prefix();
    
    /* Definice externch slovnk */
    gnome_config_push_prefix(SlovnikyPrefix);
    
    gnome_config_set_string("SLOVNIKY", p->SLOVNIKY);
    
    gnome_config_pop_prefix();
    
    /* Volby pro Gui */
    gnome_config_push_prefix(GuiPrefix);
    
    gnome_config_set_int("VIEW_INFO", zobr_info);

    gnome_config_set_int("POUZIT_ZAKAZANA", pouzit_zakazana);
    
    gnome_config_set_int("LOGOVAT_PRUBEH", pouzit_zakazana);

    gnome_config_pop_prefix();

    /* Aktualizuj konfiguran soubor */
    gnome_config_sync();

}/* end of config_uloz_nastaveni() */

/* -------------------------------------------------------------------------- */



/* ---------------------- DEFINICE LOCLNCH FUNKC ------------------------- */

/* Ulo do konfiguranho souboru defaultn hodnoty nastaven */
LOCAL void config_uloz_defaults(void) {

    boolean b;
    int i;
    char s[MAX_ROZMER];

    /* Vyistme soubor od vech ppadnch nastaven */
    gnome_config_clean_file("/scarabeus");
    gnome_config_sync();

    /* Ulo nastaven font */ 
    gnome_config_push_prefix(FontyPrefix);
    strcpy(KAMEN_FONT,
	    "-adobe-times-bold-r-normal--20-*-*-*-*-*-iso8859-2");
    gnome_config_set_string("KAMEN_FONT", KAMEN_FONT);
    strcpy(HODNOTA_FONT, 
	    "-adobe-times-bold-r-normal--10-*-*-*-*-*-iso8859-2");
    gnome_config_set_string("HODNOTA_FONT", HODNOTA_FONT);
    strcpy(POPIS_FONT,
	    "-adobe-times-bold-r-normal--12-*-*-*-*-*-iso8859-2");
    gnome_config_set_string("POPIS_FONT", POPIS_FONT);
    strcpy(BONUS_FONT,
	    "-*-helvetica-bold-r-normal--12-*-*-*-*-*-iso8859-2");
    gnome_config_set_string("BONUS_FONT", BONUS_FONT);
    gnome_config_pop_prefix();
    
    /* Ulo nastaven desky */ 
    gnome_config_push_prefix(DeskaPrefix);
    MAX_PISMEN_PRIHRADKA = 7;
    gnome_config_set_int("MAX_PISMEN_PRIHRADKA",MAX_PISMEN_PRIHRADKA);
    POC_KAMENU_SIRKA	 = 15;
    gnome_config_set_int("POC_KAMENU_SIRKA", POC_KAMENU_SIRKA);
    POC_KAMENU_VYSKA	 = 15; 
    gnome_config_set_int("POC_KAMENU_VYSKA", POC_KAMENU_VYSKA);
    VEL_KAMENE     =  32;
    gnome_config_set_int("VEL_KAMENE", VEL_KAMENE);
    gnome_config_pop_prefix();
    
    gnome_config_push_prefix(BarvyPrefix);
    red_clr    = 0xE97117FF;
    gnome_config_set_int("BARVA5", red_clr);
    cyan_clr   = 0xA5D7EFFF;
    gnome_config_set_int("BARVA2", cyan_clr);
    blue_clr   = 0x00B4DFFF;
    gnome_config_set_int("BARVA3", blue_clr);
    pink_clr   = 0xF7BB83FF;
    gnome_config_set_int("BARVA4", pink_clr);
    green_clr  = 0x5BBD29FF;
    gnome_config_set_int("BARVA1", green_clr);
    gnome_config_pop_prefix();
    
    /* Hodnoty psmen, poty a umstn bonusovch pol */
    gnome_config_push_prefix(KamenyPrefix);
    
    SLOVOX2	= 2; SLOVOX3	= 3;
    PISMX2	= 2; PISMX3	= 3;
    gnome_config_set_int("SLOVOX2", SLOVOX2);
    gnome_config_set_int("SLOVOX3", SLOVOX3);
    gnome_config_set_int("PISMX2", PISMX2);
    gnome_config_set_int("PISMX3", PISMX3);

    strcpy(SLOVO2POLE,
	"2,2;2,14;3,3;3,13;4,4;4,12;5,5;5,11;8,8;11,5;11,11;12,4;12,12;13,3;13,13;14,2;14,14;");
    gnome_config_set_string("SLOVO2POLE", SLOVO2POLE);
    strcpy(SLOVO3POLE, 
	"1,1;1,8;1,15;8,1;8,15;15,1;15,8;15,15;");
    gnome_config_set_string("SLOVO3POLE", SLOVO3POLE);
    strcpy(PISMENO2POLE, 
	"1,4;1,12;3,7;3,9;4,1;4,8;4,15;7,3;7,7;7,9;7,13;8,4;8,12;9,3;9,7;9,9;9,13;12,1;12,8;12,15;13,7;13,9;15,4;15,12;");
    gnome_config_set_string("PISMENO2POLE", PISMENO2POLE);
    strcpy(PISMENO3POLE, 
	"2,6;2,10;6,2;6,6;6,10;6,14;10,2;10,6;10,10;10,14;14,6;14,10;");
    gnome_config_set_string("PISMENO3POLE", PISMENO3POLE);

    strcpy(SADA_PISMEN,
        "a,1,5;,2,2;b,3,2;c,2,3;,4,1;d,1,3;,8,1;e,1,5;,3,2;,3,2;f,5,1;g,5,1;h,2,3;i,1,4;,2,3;j,2,2;k,1,3;l,1,3;m,2,3;n,1,5;,6,1;o,1,6;,7,1;p,1,3;r,1,3;,4,2;s,1,4;,4,2;t,1,4;,7,1;u,2,3;,5,1;,4,1;v,1,4;x,10,1;y,2,2;,4,2;z,2,2;,4,1;?,0,2;");
    gnome_config_set_string("SADA_PISMEN", SADA_PISMEN);

    gnome_config_pop_prefix();
    
    /* Extern slovnky */    
    gnome_config_push_prefix(SlovnikyPrefix);

#ifndef PUBLIC_VERSION
    strcpy(SLOVNIKY, KRI_SLOVNIK_CESTA);
    strcat(SLOVNIKY, ";");
#else
    strcpy(SLOVNIKY, "");
#endif
    gnome_config_set_string("SLOVNIKY", SLOVNIKY);
    
    gnome_config_pop_prefix();
    
    /* Gui volby */    
    gnome_config_push_prefix(GuiPrefix);

    b = TRUE;
    gnome_config_set_int("VIEW_INFO", b);

    strcpy(ZAKAZANA_SOUBOR, "scarabeus.scz");
    gnome_config_set_string("ZAKAZANA_SOUBOR", ZAKAZANA_SOUBOR);
    
    b = FALSE;
    gnome_config_set_int("POUZIT_ZAKAZANA", b);

    b = FALSE;
    gnome_config_set_int("LOGOVAT_PRUBEH", b);

    gnome_config_pop_prefix();
    
    /* Max. skre */    
    gnome_config_push_prefix(SkorePrefix);

    i = 0;
    gnome_config_set_int("MAX_SKORE", i);

    strcpy(s, "Pan Tau");
    gnome_config_set_string("MAX_SKORE_JMENO", s);

    gnome_config_pop_prefix();


    /* Aktualizuj konfiguran soubor */
    gnome_config_sync();
	
}/* end of config_uloz_defaults() */

/* -------------------------------------------------------------------------- */

/* Naplnme bonusov matice potenmi hodnotami */
LOCAL void config_resetuj_matice_bonusu(void) {

    int i, j;
   
    /* Nejprve celou matici vynulujeme */
    for (i=0;i<MAX_ROZMER;i++)
       for (j=0;j<MAX_ROZMER;j++)
	    pismmult[i][j] = slovmult[i][j] = 0;	    
    
    /* Hrac pole na '1' */
    for (i=1;i<=POC_KAMENU_SIRKA;i++)
       for (j=1;j<=POC_KAMENU_VYSKA;j++)
	    pismmult[i][j] = slovmult[i][j] = 1;	    

}/* end of config_resetuj_matice_bonusu() */

/* -------------------------------------------------------------------------- */

/* Dostane etzec obsahujc stednkem oddlen absolutn cesty
 * k souborm .mat a ulo je do spojovho seznamu.
*/
LOCAL void config_napln_seznam_slovniku(char *tseznam) {

    int i, j;
    char cesta[DMAX] = "";

    slovniky_uvolni_seznam();

    i = 0;
    while(i<strlen(tseznam)) {
        
	j = 0;
        while(tseznam[i] != ';')
            cesta[j++] = tseznam[i++];
        cesta[j] = '\0';
        i++;

	
	/* Existuje vbec soubor? */
	if ((util_soubor_existuje(cesta) == FALSE)) {
	    fprintf(stderr, 
		    "Upozornn: (config.c) soubor '%s' neexistuje!\n", cesta);
	    continue;
	}
	
	/* Je to  .mat soubor? */	
	if ((slovniky_cesta_je_platna(cesta)) == FALSE)
	    fprintf(stderr, 
		"Upozornn: (config.c) '%s' nen platn soubor se slovnkem!\n", cesta);
	else
	    slovniky_pridej_slovnik(cesta);
	
    }/* end while */

#ifdef CONFIG_DEBUG
    slovniky_vypis_seznam();
#endif

}/* end of config_napln_seznam_slovniku() */

/* -------------------------------------------------------------------------- */

/* Napln promnn s nastavenmi (pro prci s Konfiguranm oknem) */
LOCAL void config_napln_nastaveni(void) {
    
    char *polozka = NULL;
    char *s = NULL;
    int i;

    /* Fonty */
    strcpy(akt.KAMEN_FONT, KAMEN_FONT);
    strcpy(nov.KAMEN_FONT, KAMEN_FONT);
    strcpy(akt.HODNOTA_FONT, HODNOTA_FONT);
    strcpy(nov.HODNOTA_FONT, HODNOTA_FONT);
    strcpy(akt.POPIS_FONT, POPIS_FONT); 
    strcpy(nov.POPIS_FONT, POPIS_FONT); 
    strcpy(akt.BONUS_FONT, BONUS_FONT);
    strcpy(nov.BONUS_FONT, BONUS_FONT);

    /* Deska */
    akt.MAX_PISMEN_PRIHRADKA = MAX_PISMEN_PRIHRADKA;
    nov.MAX_PISMEN_PRIHRADKA = MAX_PISMEN_PRIHRADKA;
    akt.POC_KAMENU_SIRKA = POC_KAMENU_SIRKA;
    nov.POC_KAMENU_SIRKA = POC_KAMENU_SIRKA;
    akt.POC_KAMENU_VYSKA = POC_KAMENU_VYSKA;
    nov.POC_KAMENU_VYSKA = POC_KAMENU_VYSKA;
    akt.VEL_KAMENE = VEL_KAMENE;
    nov.VEL_KAMENE = VEL_KAMENE;
   
    /* Barvy */
    akt.BARVA1 = nov.BARVA1 = green_clr;
    akt.BARVA2 = nov.BARVA2 = cyan_clr;
    akt.BARVA3 = nov.BARVA3 = blue_clr;
    akt.BARVA4 = nov.BARVA4 = pink_clr;
    akt.BARVA5 = nov.BARVA5 = red_clr;

    /* Kameny */
    akt.SLOVOX2 = SLOVOX2; nov.SLOVOX2 = SLOVOX2;
    akt.SLOVOX3 = SLOVOX3; nov.SLOVOX3 = SLOVOX3;
    akt.PISMX2 = PISMX2; nov.PISMX2 = PISMX2;
    akt.PISMX3 = PISMX3; nov.PISMX3 = PISMX3;

    strcpy(akt.SLOVO2POLE, SLOVO2POLE);
    strcpy(nov.SLOVO2POLE, SLOVO2POLE);
    strcpy(akt.SLOVO3POLE, SLOVO3POLE);
    strcpy(nov.SLOVO3POLE, SLOVO3POLE);
    strcpy(akt.PISMENO2POLE, PISMENO2POLE);
    strcpy(nov.PISMENO2POLE, PISMENO2POLE);
    strcpy(akt.PISMENO3POLE, PISMENO3POLE);
    strcpy(nov.PISMENO3POLE, PISMENO3POLE);

    /* Sada kamen */
    strcpy(akt.SADA_PISMEN, SADA_PISMEN);
    strcpy(nov.SADA_PISMEN, SADA_PISMEN);

    /* Extern slovnky */
    strcpy(akt.SLOVNIKY, ""); strcpy(nov.SLOVNIKY, "");
    for(i=0;i<slovniky_dej_pocet();i++) {
        s = slovniky_dej_slovnik(i);
        polozka = g_strconcat(s, ";", NULL);
        strcat(akt.SLOVNIKY, polozka);
        strcat(nov.SLOVNIKY, polozka);
        g_free((gpointer) polozka);
    }/* end for */


}/* end of config_napln_nastaveni() */

/* -------------------------------------------------------------------------- */

/* Napln pslunou matici pro bonusov pole na souadnicch v
 * etzci hodnotou 'hodnota.
 * 'co' == 0 --=> plnme psmenn bonusy
 * 'co' == 1 --=> plnme slovn bonusy
*/
LOCAL void config_napln_matici_bonusu(char *souradnice, int hodnota, int co) {

    int i, j;
    int x, y;
    char pom[10] = ""; /* Maximln me bt "50,50;" (6+1 znak) */ 

    i = 0;
    while(i<strlen(souradnice)) {
        
	j = 0;
        while(souradnice[i] != ';')
            pom[j++] = souradnice[i++];
        pom[j] = '\0';
        i++;

	sscanf(pom, "%d,%d", &x, &y); /* Vysekej souadnice z "X,Y" */

	/* Podvren hodnoty? */
	if ((x > POC_KAMENU_VYSKA) || (y > POC_KAMENU_SIRKA))
	    continue;

	/* Plnme psmenn nebo slovn bonusov pole */

	if (co) {	/* Slovn */
	    slovmult[x][y] = hodnota; 
	}
	else {		/* Psmenn */
	    pismmult[x][y] = hodnota;
	}
	
    }/* end while */

}/* end of config_napln_matici_bonusu() */

/* -------------------------------------------------------------------------- */

#ifdef CONF_DEBUG
/* Vype naten nastaven */
LOCAL void config_zobraz_nastaveni(void) {

    printf("\n[Fonty]\n");
    printf("KAMEN_FONT=%s\n", KAMEN_FONT);
    printf("HODNOTA_FONT=%s\n", HODNOTA_FONT);
    printf("POPIS_FONT=%s\n", POPIS_FONT);
    printf("BONUS_FONT=%s\n", BONUS_FONT);
    printf("\n[Deska]\n");
    printf("MAX_PISMEN_PRIHRADKA=%d\n", MAX_PISMEN_PRIHRADKA);
    printf("POC_KAMENU_SIRKA=%d\n", POC_KAMENU_SIRKA);
    printf("POC_KAMENU_VYSKA=%d\n", POC_KAMENU_VYSKA); 
    printf("VEL_KAMENE=%d\n", VEL_KAMENE);
    printf("\n[Okno]\n");
    printf("\n[Barvy]\n");
    printf("BARVA1=%X\n", white_clr);
    printf("BARVA2=%X\n", black_clr);
    printf("BARVA3=%X\n", red_clr);
    printf("BARVA4=%X\n", cyan_clr);
    printf("BARVA5=%X\n", blue_clr);
    printf("\n[Kameny]\n");
    printf("SLOVOX2=%d\n", SLOVOX2);
    printf("SLOVOX3=%d\n", SLOVOX3);
    printf("PISMX2=%d\n", PISMX2);
    printf("PISMX3=%d\n", PISMX3);
    printf("SLOVO2POLE=%s\n", SLOVO2POLE);
    printf("SLOVO3POLE=%s\n", SLOVO3POLE);
    printf("PISMENO2POLE=%s\n", PISMENO2POLE);
    printf("PISMENO3POLE=%s\n", PISMENO3POLE);
    printf("\n[Slovniky]\n");
    printf("SLOVNIKY=%s\n", SLOVNIKY);
    printf("\n[Gui]\n");
    printf("VIEW_INFO=%s\n", zobr_info);
    printf("POUZIT_ZAKAZANA=%s\n", pouzit_zakazana);
    printf("LOGOVAT_PRUBEH=%s\n", logovat_prubeh);

}/* end of config_zobraz_nastaveni() */
#endif

/* -------------------------------------------------------------------------- */

/* Zobraz na chybov vstup hlku o nedostupnosti fontu */
LOCAL void config_font_nelze_nahrat(char *font) {

    fprintf(stderr, "config.c: Font '%s' nelze nahrt!\n", font);

}/* end of config_font_nelze_nahrat() */

/* -------------------------------------------------------------------------- */

/* Zjist, zda je mon nahrt font 'font' a ppadn vype chybu */
LOCAL void config_otestuj_font(char *font) {

    testfont = gdk_font_load(font); 
    if ( testfont == NULL)
	config_font_nelze_nahrat(font);
    else
	gdk_font_unref(testfont);
    
}/* end of config_otestuj_font() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE config.c */
