/* -------------------------- DEFINE SEKCE ---------------------------------- */

#define Prefix                  "/scarabeus/"
#define GuiPrefix               "/scarabeus/Gui/"
#define FontyPrefix             "/scarabeus/Fonty/"
#define OknoPrefix              "/scarabeus/Okno/"
#define DeskaPrefix             "/scarabeus/Deska/"
#define BarvyPrefix             "/scarabeus/Barvy/"
#define KamenyPrefix            "/scarabeus/Kameny/"
#define SlovnikyPrefix          "/scarabeus/Slovniky/"
#define SkorePrefix          	"/scarabeus/Skore/"

/* ---------------------------- TYPEDEF SEKCE ------------------------------- */

/* Obsahuje vechny poloky v menu 'Konfigurace' */
typedef struct {

    char KAMEN_FONT[DMAX];
    char HODNOTA_FONT[DMAX];
    char POPIS_FONT[DMAX];
    char BONUS_FONT[DMAX];

    int MAX_PISMEN_PRIHRADKA;
    int POC_KAMENU_SIRKA;
    int POC_KAMENU_VYSKA;

    int VEL_KAMENE;

    unsigned int BARVA1;        /* normal */
    unsigned int BARVA2;        /* 2xP */
    unsigned int BARVA3;        /* 3xP */
    unsigned int BARVA4;        /* 2xS */
    unsigned int BARVA5;        /* 3xS */

    int SLOVOX2;
    int SLOVOX3;
    int PISMX2;
    int PISMX3;

    char SLOVO2POLE[DMAX];
    char SLOVO3POLE[DMAX];
    char PISMENO2POLE[DMAX];
    char PISMENO3POLE[DMAX];
    char SADA_PISMEN[2*DMAX];
    char SLOVNIKY[10*DMAX];

} tpreference;

/* ----------------------- EXPORTOVAN PROMNN ----------------------------- */

/* Bonusov pole */
EXPORT char slovmult[MAX_ROZMER][MAX_ROZMER];	/* Pole se slovnmi bonusy */
EXPORT char pismmult[MAX_ROZMER][MAX_ROZMER];	/* Pole s psmennmi bonusy */

/* Cesta k souboru se zakzanmi slovy */
EXPORT char ZAKAZANA_SOUBOR[DMAX];

/* Cesta k souboru pro logovani */
EXPORT char LOGOVANI_SOUBOR[DMAX];

/* Fonty */
EXPORT char KAMEN_FONT[DMAX];
EXPORT char HODNOTA_FONT[DMAX];
EXPORT char POPIS_FONT[DMAX];
EXPORT char BONUS_FONT[DMAX];

/* Deska */
EXPORT int MAX_PISMEN_PRIHRADKA;
EXPORT int POC_KAMENU_SIRKA;		/* rozmry desky */
EXPORT int POC_KAMENU_VYSKA; 

/* Okno */
EXPORT int VEL_OKNO_SIRKA;		/* v bodech */
EXPORT int VEL_OKNO_VYSKA;
EXPORT int VEL_KAMENE;			
EXPORT int VEL_BONUS_POLE;
EXPORT int VEL_CANVAS_SIRKA;
EXPORT int VEL_CANVAS_VYSKA;
EXPORT int VEL_DESKA_SIRKA;
EXPORT int VEL_DESKA_VYSKA;
EXPORT int VEL_RACK_SIRKA;
EXPORT int VEL_RACK_VYSKA;
EXPORT int VEL_OKRAJ_DESKY;

EXPORT int HOFFX;
EXPORT int HOFFY;
EXPORT int POFFX;
EXPORT int POFFY;

/* Barvy */
EXPORT unsigned int white_clr;
EXPORT unsigned int black_clr;
EXPORT unsigned int red_clr;
EXPORT unsigned int cyan_clr;
EXPORT unsigned int blue_clr;
EXPORT unsigned int pink_clr;
EXPORT unsigned int green_clr;
EXPORT unsigned int yellow_clr;
EXPORT unsigned int gray_clr;

/* Kameny */
EXPORT int SLOVOX2;
EXPORT int SLOVOX3;
EXPORT int PISMX2;
EXPORT int PISMX3;

/* Sada psmen */
EXPORT char SADA_PISMEN[2*DMAX];

/* Kolekce nastaven pro prci s PropertyBoxem */
EXPORT tpreference akt; 
EXPORT tpreference nov;        

EXPORT boolean zobr_info;
EXPORT boolean pouzit_zakazana;

/* Zda logovat prbh hry, nabv hodnot 0/1 + ppadn pznak
 * na 2. bitu (tedy max 3 dec), kter k, zda pouvme std.
 * logovac soubor i vybran.
*/
EXPORT int logovat_prubeh;

EXPORT int obtiznost_hry;

/* ------------------------ EXPORTOVAN FUNKCE  ----------------------------- */

EXPORT void config_nacti_nastaveni(void);
EXPORT void config_uloz_nastaveni(tpreference *p);

/* -------------------------------------------------------------------------- */

/* END_OF_FILE config.h */
