#include<gnome.h>
#include<ctype.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "version.h"
#include "config.h"
#include "automat.h"
#include "vacek.h"
#include "cross.h"
#include "prihradka.h"
#include "deska.h"
#include "skore.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "gui_logovani.h"
#include "tahy_seznam.h"
#include "tahy_gen.h"
#include "tahy_gui.h"
#include "konverze.h"
#include "logovani.h"
#include "hra.h"

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

/* Definice pomocnch promnnch */
GLOBAL gui_policko board_grid[MAX_ROZMER][MAX_ROZMER]; /* gui */
GLOBAL gui_policko rack_grid[MAX_ROZMER][1];           /* gui */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL char prubeh_dej_typ(int poradi);
GLOBAL int  prubeh_dej_pocet(void);
GLOBAL void prubeh_nastav_index(int poradi);

GLOBAL void set_tooltip(GtkWidget* w, const gchar* tip);

GLOBAL void board_set_tile_active(int x, int y);
GLOBAL void board_draw_loaded(void);
GLOBAL void board_draw_field(int x, int y, 
			     guint32 barva, guint32 text_barva,
			     char *p, char *h);
GLOBAL void board_revert_tile_to_empty(int x, int y);
GLOBAL void board_set_tile_rect_color(int x, int y, guint32 barva);
GLOBAL void board_set_placed_tiles_color(void);
GLOBAL void rack_empty_tile(int what);
GLOBAL void rack_return_played_tiles_home(void);
GLOBAL void show_warning_window (GtkWindow *main_window, char *message);
GLOBAL void show_info_window (GtkWindow *main_window, char *message);
GLOBAL void draw_a_line(GnomeCanvasGroup *group, 
		       int x1, int y1, int x2, int y2, 
		       char *color);
GLOBAL void vytvor_policko(GnomeCanvasGroup *group, gui_policko *sit, 
		       int x, int y,	
		       guint32 barva, 
		       char *pismeno, int hodnota);
GLOBAL void copy_properties(gui_policko dst, gui_policko src);    
GLOBAL void exchange_properties(gui_policko *dst, gui_policko *src);
GLOBAL void set_empty_tile_properties(int x, int y, char *text, guint32 *barva);
GLOBAL void zapis_tah_do_tabulky(int mod, int howmany);
GLOBAL void zapis_seznam_tahu_do_tabulky(void);

/* Pro MENU */
GLOBAL void about_cb(GtkWidget *widget, gpointer data);
GLOBAL void gui_testuj_slovo(GtkWidget *w, gpointer data);
GLOBAL void gui_nabidni_tip(void);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* Nastav text tooltipu pro dan widget */
GLOBAL void set_tooltip(GtkWidget* w, const gchar* tip)
{
  GtkTooltips *t = gtk_tooltips_new();

  gtk_tooltips_set_tip (t, w, tip, NULL);
}/* end of set_tooltip */

/* -------------------------------------------------------------------------- */

/* Zobraz okno s textentry pro otestovn platnosti slova */
GLOBAL void gui_testuj_slovo(GtkWidget *w, gpointer data) {

  GtkWidget *dialog;
  GtkWidget *label;
  GtkWidget *textentry;
  int reply;
  char slovo[MAX_ROZMER+1];

  /* Je tu proto, aby byl naten slovnk!!! */
  if (game_mode != PLAY_MODE) {
      show_info_window(GTK_WINDOW(app), 
	    "Nen zatm k dispozici, nebyl naten slovnk\n"
	    "pro hru. Spuste, prosm, novou hru.");
      return;
  }
  
  dialog = gnome_dialog_new(N_("Testuj slovo"), 
                            GNOME_STOCK_BUTTON_OK,
                            GNOME_STOCK_BUTTON_CANCEL,
                            NULL);
  gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
  gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
  gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
  gnome_dialog_set_parent (GNOME_DIALOG (dialog), GTK_WINDOW(app));

  label = gtk_label_new("Testuj slovo");
  textentry = gtk_entry_new_with_max_length(MAX_ROZMER);

  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                     label, TRUE, TRUE, GNOME_PAD);
  gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                     textentry, TRUE, TRUE, GNOME_PAD);
  gnome_dialog_editable_enters(GNOME_DIALOG(dialog), GTK_EDITABLE(textentry));
  gtk_widget_grab_focus(textentry);
  
  gtk_widget_show_all(dialog);

  reply = gnome_dialog_run(GNOME_DIALOG(dialog));
  
  if (reply == GNOME_OK)
    {      
      strcpy(slovo, gtk_entry_get_text(GTK_ENTRY(textentry)));

      if ( (testuj_retezec(slovo)) == FALSE)
	  show_info_window(GTK_WINDOW(dialog), "NE - slovo neznm!");
      else
	  show_info_window(GTK_WINDOW(dialog), "ANO - slovo je platn!");

    }

    gtk_widget_destroy(dialog);   
 
}/* end of gui_testuj_slovo() */

/* -------------------------------------------------------------------------- */

/* Nabdne uivateli tah */
GLOBAL void gui_nabidni_tip(void) {
}/* end of gui_nabidni_tip() */


/* -------------------------------------------------------------------------- */

/* Pomocn funkce pro vykreslen seky */
GLOBAL void draw_a_line(GnomeCanvasGroup *group,
      int x1, int y1, int x2, int y2, char *color)
{
  GnomeCanvasPoints *points;
  
  /* Vytvo dvouprvkov pole pro 2 souadnice */
  points = gnome_canvas_points_new (2);
  
  /* Napl jej hodnotami pro koncov body seky */
  points->coords[0] = x1;
  points->coords[1] = y1;
  points->coords[2] = x2;
  points->coords[3] = y2;
  /* Vykresli seku*/
  gnome_canvas_item_new(group,
            gnome_canvas_line_get_type(),
            "points", points,
            "fill_color", color,
            "width_units", (double) TLOUSTKA_CARY,
            NULL);
      
  /* U nepotebujeme */
  gnome_canvas_points_free(points);
}

/* -------------------------------------------------------------------------- */

/* Vytvo v dan GnomeCanvasGroup skupinu obsahujc barevn pole
 * se znakem a hodnotou kamene.
*/
GLOBAL void vytvor_policko(GnomeCanvasGroup *group, gui_policko *sit, 
			  int x, int y,	
		          guint32 barva, 
			  char *pismeno, int hodnota)
{
   
    char cislo[5] = "";
    gchar font[256] = "";
    gint offx, offy;

    if (hodnota != EMPTY_TILE) {	/* -1 indikuje przdn polko */
	sprintf(cislo, "%d", hodnota);
	strcpy(font,KAMEN_FONT); 
	offx = 0; offy = 0;
    }
    else {
	strcpy(font,KAMEN_FONT);
	offx = 0; offy = 0;
    }
    sit->skupina = GNOME_CANVAS_GROUP(gnome_canvas_item_new(group,
               	        gnome_canvas_group_get_type(),
			"x", (double) x*VEL_KAMENE,
			"y", (double) y*VEL_KAMENE,
			NULL));
   

    sit->obdelnik = gnome_canvas_item_new(sit->skupina,
	                 gnome_canvas_rect_get_type(),
		         "x1",(double) VYPLN,
			 "y1",(double) VYPLN,
			 "x2",(double) VEL_KAMENE-VYPLN,
		         "y2",(double) VEL_KAMENE-VYPLN,
                         "fill_color_rgba", barva,
                          NULL);
    
    sit->pismeno = gnome_canvas_item_new(sit->skupina,
		         gnome_canvas_text_get_type(),
			  "x", (double) VEL_KAMENE-POFFX+offx,
			  "y", (double) VEL_KAMENE-POFFY+offy,
			  "anchor", GTK_ANCHOR_CENTER,
			  "font", font,
			  "fill_color_rgba", black_clr,
			  "text", pismeno,
			  NULL);

     sit->hodnota = gnome_canvas_item_new(sit->skupina,
			  gnome_canvas_text_get_type(),
			  "x", (double) VEL_KAMENE-HOFFX,
			  "y", (double) VEL_KAMENE-HOFFY,
			  "anchor", GTK_ANCHOR_CENTER,
			  "font", HODNOTA_FONT,
			  "fill_color_rgba", black_clr,
			  "text", cislo,
			  NULL);


}

/* -------------------------------------------------------------------------- */

/* Zobraz nalezen tahy do Clistu, seazen podle bod. Zobraz dle
 * souadnice, kde slovo zan. Do frame zobraz poet nalezench tah.
*/
GLOBAL void zapis_seznam_tahu_do_tabulky(void) {

    int i, j;
    int pocet;
    char *radek[3];
    char body[10] = "";
    char sour[10] = "";
    char slovo[MAX_ROZMER] = "";
    char label[MAX_ROZMER] = "";
    Tah t;
    tpozice p;


    /* Nekupme vechny tahy za sebe */
    gtk_clist_clear(GTK_CLIST(pomoc_clist));

    pocet = tahy_seznam_dej_delku();
    strcpy(label, "Pomoc - nalezeno (");
    sprintf(slovo, "%d", pocet);
    strcat(label, slovo);
    strcat(label, ") slov");
    gtk_frame_set_label(GTK_FRAME(pomoc_frame), label);
    
    for(i=0;i<pocet;i++) {

	/* Zskej celou strukturu pro Tah */
	t = tahy_seznam_dej_polozku(i);
	
	/* Skre je slo, peve */
	sprintf(body, "%d", t.skore);

	/* Zskej sprvnou orientaci pozice */
	p.x = (t.o == SD) ? t.p.y : t.p.x;
	p.y = (t.o == SD) ? t.p.x : t.p.y;
	
	pos2string(p, t.o, sour);

	/* Nen to '0' ukonen etzec */
	for(j=0;j<t.slen;j++)
	    slovo[j] = t.s[j];
	slovo[j] = '\0';
	
	radek[0] = body;
	radek[1] = sour;
	radek[2] = slovo;;
    
	/* Voila! */
	gtk_clist_append(GTK_CLIST(pomoc_clist), radek);

    }/* end for */
	
}/* end of zapis_seznam_tahu_do_tabulky() */

/* -------------------------------------------------------------------------- */

/* Pidej do tabulky s prbhem hry dek o odehranch kamenech, skre,... */
GLOBAL void zapis_tah_do_tabulky(int mod, int howmany) {

    char tah[10] = "";		/* slo tahu */
    char hracj[50] = "";	/* jmno hre */
    char slovo[50] = "";	/* odehran slovo */
    char sour[10] = "";		/* na kterch souadnicch zan? */
    char sbody[10] = "0";	/* za kolik bod */
    char *radek[5];
    char str[20] = "";
    int k, tbody; 
    tpozice pom;
    torientace o;
    boolean stav;
    char co;


    sprintf(tah, "%d", hra_dej_poradi_tahu());
   
    if (player == HRAC1) 
	strcpy(hracj, (char *) gtk_entry_get_text(GTK_ENTRY(player1_name)));
    else
	strcpy(hracj, (char *) gtk_entry_get_text(GTK_ENTRY(player2_name)));

#if 0
    /* Budeme logovat prbh hry? */
    if (logovat_prubeh & 1) {

	/* V Tahu 1,3,5,... loguj zsobnky + body) */
	if (hra_dej_poradi_tahu() % 2)
	    if (logovani_zapis_zas_skore() == FALSE)
		gui_logovani_chyba(GTK_WINDOW(app));

    }/* end if logujeme? */
#endif
   
    if (mod == TAH_ODEHRANI_KAMENU) {
	/* Odehran slovo se vdy nachz v glob. promnn 'nenalezeno[]' */
	/* Nutno zmnit na mal psmena */
	for(k=0;k<strlen(odehravane);k++)
	    slovo[k] = tolower(odehravane[k]);
	slovo[k] = '\0';
    
	/* Zskej nejlevj psmeno ze slova, kter jsme umstili */
	pom = tahy_nejlevejsi_pismeno();

	/* Spoti, kolik bod jsme za nj dostali */	
	o = (horizontal) ? ZD : SD;
	tbody = tahy_spocitej_body(player, pom, o);
	sprintf(sbody,"%d", tbody);

	/* Uprav celkov skre aktulnho hre */	
	if (player == HRAC1)
	    skore_h1 += tbody;
	else
	    skore_h2 += tbody;

	/* Vypisujeme podle orientace bu nap. '15A' nebo 'A15' */
	pos2string(pom, o, sour);

	prubeh_typ[prubeh_kolik++] = 'h';	/* ode'h'rlo se */

    }/* end if (TAH_ODEHRANI_KAMENU) */
    
    if (mod == TAH_VYMENA_KAMENU) { /* Vmna kamen */

	strcpy(sbody, "---");
	strcpy(sour, "---");
	strcpy(slovo, "VMNA(");
	sprintf(str, "%d", howmany);
	strcat(slovo, str);
	strcat(slovo, ")");

	prubeh_typ[prubeh_kolik++] = 'v';	/* 'v'ymnilo se */

    }/* end if (TAH_VYMENA_KAMENU) */

    if (mod == TAH_PROVEDEN_PASS) { /* Proveden PASS */

	strcpy(sbody, "---");
	strcpy(sour, "---");
	strcpy(slovo, "PASS");

	prubeh_typ[prubeh_kolik++] = 'p';	/* 'p'ass */

    }/* end if (TAH_PROVEDEN_PASS) */

    if (mod == TAH_PROVEDEN_ODPIS) { /* Proveden ODPIS */

	sprintf(sbody, "%d", howmany);
	strcpy(sour, "---");
	
	if (howmany >= 0)
	    strcpy(slovo, "PPIS");
	else
	    strcpy(slovo, "ODPIS");

	prubeh_typ[prubeh_kolik++] = 'o';	/* 'o'dpis */

    }/* end if (TAH_PROVEDEN_ODPIS) */

    /* Poskldej vstup */    
    radek[0] = tah;
    radek[1] = hracj;
    radek[2] = sbody;
    radek[3] = sour;
    radek[4] = slovo;    

    /* Budeme logovat prbh hry? */
    if (logovat_prubeh & 1) {

	co = prubeh_typ[prubeh_kolik-1];

	/* odehravme */
	if (co == 'h')
	    stav = logovani_zapis_odehrany_tah( hra_dej_poradi_tahu(),
		   player, 'h', tbody, o, pom.x, pom.y, slovo);
	/* vmna */
	if (co == 'v')
	    stav = logovani_zapis_odehrany_tah( hra_dej_poradi_tahu(),
		   player, 'v', howmany, HORIZONTAL, 0, 0, "VMNA");
	/* pass */
	if (co == 'p')
	    stav = logovani_zapis_odehrany_tah( hra_dej_poradi_tahu(),
		   player, 'p', 0, HORIZONTAL, 0, 0, "PASS");
	/* odpis/ppis */
	if (co == 'o') {
            if (howmany >= 0)
                stav = logovani_zapis_odehrany_tah( hra_dej_poradi_tahu(),
                       player, 'o', howmany, HORIZONTAL, 0, 0, "PPIS");
            else
                stav = logovani_zapis_odehrany_tah( hra_dej_poradi_tahu(),
                       player, 'o', howmany, HORIZONTAL, 0, 0, "ODPIS");
	}

	/* Nco se nepovedlo, dle neloguj */	
	if (stav == FALSE)
	    gui_logovani_chyba(GTK_WINDOW(app));
	    
    }/* end if logovani */
    
    gtk_clist_append(GTK_CLIST(prubeh_clist), radek);
    gtk_clist_moveto(GTK_CLIST(prubeh_clist), prubeh_kolik-1, 0, 0, 0);

}/* end of zapis_tah_do_tabulky() */

/* -------------------------------------------------------------------------- */

/* Zkopruje znak a hodnotu kamene ze src -> dst */
GLOBAL void copy_properties(gui_policko dst, gui_policko src)
{
  
  GnomeCanvasText *pism;
  GnomeCanvasText *hodn;
  GnomeCanvasRE *rect;
	
  pism = GNOME_CANVAS_TEXT(src.pismeno);
  hodn = GNOME_CANVAS_TEXT(src.hodnota);
  rect = GNOME_CANVAS_RE(src.obdelnik);
    
    gnome_canvas_item_set(dst.pismeno,
			      "font", KAMEN_FONT,
			      "x", pism->x,
			      "y", pism->y,
			      "fill_color_rgba", black_clr,
			      "text", pism->text, 
			      NULL);
    gnome_canvas_item_set(dst.hodnota,
			      "x", hodn->x,
			      "y", hodn->y,
			      "font", HODNOTA_FONT,
			      "fill_color_rgba", black_clr,
			      "text", hodn->text, 
			      NULL);
    gnome_canvas_item_set(dst.obdelnik,
			      "fill_color_rgba", yellow_clr,
			      NULL);

}/* end of copy_properties() */

/* -------------------------------------------------------------------------- */

/* Vymn vlastnosti polka (obdelnik, pismeno, hodnota)
 * dvou pol
*/
GLOBAL void exchange_properties(gui_policko *dst, gui_policko *src)
{
  
  GnomeCanvasText *pism, *ppism;
  GnomeCanvasText *hodn, *phodn;
  GnomeCanvasRE *rect, *prect;
	
  pism = GNOME_CANVAS_TEXT(src->pismeno);
  hodn = GNOME_CANVAS_TEXT(src->hodnota);
  rect = GNOME_CANVAS_RE(src->obdelnik);
  
  ppism = GNOME_CANVAS_TEXT(dst->pismeno);
  phodn = GNOME_CANVAS_TEXT(dst->hodnota);
  prect = GNOME_CANVAS_RE(dst->obdelnik);

  
    gnome_canvas_item_set(dst->obdelnik,
			      "fill_color_rgba", yellow_clr,
			      NULL);
    gnome_canvas_item_set(dst->pismeno,
			      "font", KAMEN_FONT,
			      "x", pism->x, "y", pism->y,
			      "fill_color_rgba", black_clr,
			      "text", pism->text, 
			      NULL);
    gnome_canvas_item_set(dst->hodnota,
			      "x", hodn->x, "y", hodn->y,
			      "font", HODNOTA_FONT,
			      "fill_color_rgba", black_clr,
			      "text", hodn->text, 
			      NULL);
    gnome_canvas_item_set(src->obdelnik,
			      "fill_color_rgba", yellow_clr,
			      NULL);
    gnome_canvas_item_set(src->pismeno,
			      "font", KAMEN_FONT,
			      "x", ppism->x, "y", ppism->y,
			      "fill_color_rgba", black_clr,
			      "text", ppism->text, 
			      NULL);
    gnome_canvas_item_set(src->hodnota,
			      "x", phodn->x, "y", phodn->y,
			      "font", HODNOTA_FONT,
			      "fill_color_rgba", black_clr,
			      "text", phodn->text, 
			      NULL);

}/* end of exchange_properties() */

/* -------------------------------------------------------------------------- */

/* Nastav vlastnosti pro przdn pole na pozici [x,y] se
 * sprvnm nastaven barvy pole a jeho textu (bonusov pole)
*/
GLOBAL void set_empty_tile_properties(int x, int y, char *text, guint32 *barva) {
    
    int k;
    
    strcpy(text, EMPTY_WORD);
    k = slovmult[x+1][y+1];
    
	if (k == 1) *barva = green_clr;
        if (k == SLOVOX2) { *barva = pink_clr; strcpy(text,SLOVO2); }
	if (k == SLOVOX3) { *barva = red_clr;  strcpy(text,SLOVO3); }
	
	if (k == 1)
	{
	    k = pismmult[x+1][y+1];
       		if (k == PISMX2) { *barva = cyan_clr; strcpy(text,PISMENO2); }
		if (k == PISMX3) { *barva = blue_clr; strcpy(text,PISMENO3); }	
	}
    strcpy(text, EMPTY_WORD);

}/* end of set_empty_tile_properties() */

/* -------------------------------------------------------------------------- */

/* Po pesunu kamene umstnho na desce na jin neobsazen
 * pole potebujeme pvodn pole nastavit jako przdn
*/
GLOBAL void board_revert_tile_to_empty(int x, int y) {

    char text[10];
    guint32 barva;
    GnomeCanvasText *pism;

    pism=GNOME_CANVAS_TEXT(board_grid[x][y].pismeno);

    set_empty_tile_properties(x, y, text, &barva);
    
    gnome_canvas_item_set(board_grid[x][y].pismeno,
			      "x", (pism->x),
			      "y", (pism->y),
			      "font", KAMEN_FONT,
			      "fill_color_rgba", black_clr,
			      "text", text, 
			      NULL);
    gnome_canvas_item_set(board_grid[x][y].hodnota,
			      "font", HODNOTA_FONT,
			      "fill_color_rgba", black_clr,
			      "text", "", 
			      NULL);
    gnome_canvas_item_set(board_grid[x][y].obdelnik,
			      "fill_color_rgba", barva,
			      NULL);
	
}/* end of board_revert_tile_to_empty() */

/* -------------------------------------------------------------------------- */

/* Ozna kmen z racku umstn na desce */
GLOBAL void board_set_tile_active(int x, int y) {
    
    gnome_canvas_item_set(board_grid[x][y].pismeno,
			      "fill_color_rgba", yellow_clr,
			      NULL);
    gnome_canvas_item_set(board_grid[x][y].hodnota,
			      "fill_color_rgba", yellow_clr,
			      NULL);
    gnome_canvas_item_set(board_grid[x][y].obdelnik,
			      "fill_color_rgba", black_clr,
			      NULL);

}/* end of board_set_tile_active() */

/* -------------------------------------------------------------------------- */

/* Po pesunu kamenu na plochu vyprzdni pslun msto v racku */
GLOBAL void rack_empty_tile(int what) {

	gnome_canvas_item_set(rack_grid[what][0].obdelnik,
		              "fill_color_rgba", yellow_clr,
			       NULL);	
	gnome_canvas_item_set(rack_grid[what][0].pismeno,
		              "fill_color_rgba", black_clr,
			      "font", KAMEN_FONT,
			      "text", EMPTY_WORD,
			       NULL);	
	gnome_canvas_item_set(rack_grid[what][0].hodnota,
		              "fill_color_rgba", black_clr,
			      "font", HODNOTA_FONT,
			      "text", EMPTY_WORD,
			       NULL);	
}/* end of rack_empty_tile() */

/* -------------------------------------------------------------------------- */

/* Nastav barvu obdlnku pro danou pozici */
GLOBAL void board_set_tile_rect_color(int x, int y, guint32 barva) {
    
    gnome_canvas_item_set(board_grid[y][x].obdelnik,
			       "fill_color_rgba", barva, NULL);
    gnome_canvas_item_set(board_grid[y][x].pismeno,
                               "fill_color_rgba", black_clr, NULL);
    gnome_canvas_item_set(board_grid[y][x].hodnota,
                               "fill_color_rgba", black_clr, NULL);

}/* end of board_set_tile_rect_color() */

/* -------------------------------------------------------------------------- */

/* Po ukonen rozmsovn kamen z racku (po klepnut na 'Hotovo'), obarvi
 * na blo kameny.
*/
GLOBAL void board_set_placed_tiles_color(void) {

    int i, x, y;
    skamen *rack;
    char znak;
    char spism[2];

    rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (rack_placed_tiles_coords[i].which != EMPTY_TILE) {
	  
	    x = rack_placed_tiles_coords[i].x;
	    y = rack_placed_tiles_coords[i].y; 

	    /* olka je nutn "pejmenovat" */
	    if (rack[i].znak != JOKERCHAR) 
		board_set_tile_rect_color(x, y, white_clr);
	    else {
		znak = toupper(board_get_letter_at_coords(x, y));
		spism[0] = znak; spism[1] = '\0';
		board_set_tile_rect_color(x, y, white_clr);
		gnome_canvas_item_set(board_grid[y][x].pismeno,
				    "fill_color_rgba", red_clr, 
				    "text", spism,
				    NULL);
		gnome_canvas_item_set(board_grid[y][x].hodnota,
				    "fill_color_rgba", red_clr, NULL);
	    }
	    
	}/* end if != EMPTY_TILE */

}/* end of board_set_placed_tiles_color() */

/* -------------------------------------------------------------------------- */

/* Pesu vechny prv umstn kameny na desce zpt do racku */
GLOBAL void rack_return_played_tiles_home(void) {
    
    int i, x, y, which;

    /* Jen kdy hrajeme */
    if (game_mode == STOP_MODE || game_mode == CHANGE_MODE)
	return;
      
    
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) 
	if ((which = rack_placed_tiles_coords[i].which) != EMPTY_TILE) {
	    x = rack_placed_tiles_coords[i].x;
	    y = rack_placed_tiles_coords[i].y;
	    which = rack_placed_tiles_coords[i].which;

	    /* Nen odehran */
	    rack_placed_tiles_coords[i].which = EMPTY_TILE;
	    rack_placed_tiles_coords[i].x = EMPTY_TILE;
	    rack_placed_tiles_coords[i].y = EMPTY_TILE;
	    
	    /* Nen umstn na desce */
	    rack_set_placed_on_board(which, FALSE); 
	    
	    /* Uvolni msto na desce */
	    board_set_field_vacant(x, y, TRUE);
	    board_set_tile_clicked(FALSE);

	    /* A uvolni msto po kameni i graficky */
	    board_revert_tile_to_empty(y, x);

	}/* end if */

    /* Odzna ppadn oznaen kameny */
    for (i=0; i<MAX_PISMEN_PRIHRADKA;i++)
	rack_click[i] = FALSE;
    
    draw_rack();

}/* end of rack_return_played_tiles_home() */

/* -------------------------------------------------------------------------- */

/* Zobraz informan okno s hlkou */
GLOBAL void show_info_window (GtkWindow *main_window, char *message) {

    GtkWidget *dialog, *label;
    int button;

    dialog = gnome_message_box_new(message, 
	     GNOME_MESSAGE_BOX_INFO, "OK", NULL);
    
    if (main_window)
	gnome_dialog_set_parent(GNOME_DIALOG (dialog), main_window);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);

    label = gtk_label_new (message);
    gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (dialog)->vbox), label, 
                        TRUE, TRUE, 0);

    button = gnome_dialog_run_and_close(GNOME_DIALOG (dialog));

}/* end of show_info_window() */

/* -------------------------------------------------------------------------- */

/* Zobraz modln stavov okno s upozornnm */
GLOBAL void show_warning_window (GtkWindow *main_window, char *message)
{
    GtkWidget *dialog, *label;
    int button;

    dialog = gnome_message_box_new(message, 
	     GNOME_MESSAGE_BOX_ERROR, "OK", NULL);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    
    if (main_window)
	gnome_dialog_set_parent (GNOME_DIALOG (dialog), main_window);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
    gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);

    label = gtk_label_new(message);
    gtk_box_pack_start (GTK_BOX (GNOME_DIALOG (dialog)->vbox), label, 
                        TRUE, TRUE, 0);

    button = gnome_dialog_run_and_close(GNOME_DIALOG (dialog));

}/* end of show_warning_window() */

/* -------------------------------------------------------------------------- */
/* --------------------- ABOUT OKNO S INFORMACEMI --------------------------- */
/* -------------------------------------------------------------------------- */

/* Zobraz okno s informacemi o programu */
GLOBAL void about_cb(GtkWidget *widget, gpointer data) {

  int reply;

  GtkWidget* dialog = NULL;
  /* a list of authors */
  const char *author[] = {
    "Vt Hotrek <xagon@volny.cz>",
    NULL
  };
 
  /* create the dialog */
  dialog = gnome_about_new("Scarabeus", VERSION,
         "(c) 2003 Vt Hotrek",
         author,
         "Jedna z mnoha verz oblben deskov "
         "hry Scrabble(R).\nProgram vznikl v Laboratoi "
	 " zpracovn pirozenho jazyka Fakulty"
	 " informatiky Masarykovy Univerzity Brno\n"
	 " v rmci diplomov prce.",
         NULL);

  /* set the parent of the dialog to be the main application
     window, this will help windowmanagers */
  gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));
  gnome_dialog_close_hides(GNOME_DIALOG (dialog), FALSE);
  
  gtk_window_set_modal(GTK_WINDOW(dialog), TRUE); 
  
  gtk_widget_show(dialog);

  reply = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

}/* end of about_cb */

/* -------------------------------------------------------------------------- */

/* Pro poteby SAVE_GAME si uchovvm v poli prubeh_typ[] znaky
 * podle typu odehrn ['h','v','p','o']. Funkce vrc jeden z tchto
 * znak.
*/
GLOBAL char prubeh_dej_typ(int poradi) {

    return(prubeh_typ[poradi]);
    
}/* end of prubeh_dej_typ() */

/* -------------------------------------------------------------------------- */

/* Vrac celkov poet odehrn */
GLOBAL int prubeh_dej_pocet(void) {
    
    return(prubeh_kolik);
    
}/* end of prubeh_dej_pocet() */

/* -------------------------------------------------------------------------- */

GLOBAL void prubeh_nastav_index(int poradi) {
    
    prubeh_kolik = poradi;

}/* end of prubeh_nastav_index() */

/* -------------------------------------------------------------------------- */

/* Na pole x,y vykresl na pozad barvy 'barva' psmeno v 'p' a hodnotu v 'h' */
GLOBAL void board_draw_field(int x, int y, 
			     guint32 barva, 
	                     guint32 text_barva,
			     char *p, char *h) {

    board_set_tile_rect_color(y, x, barva);
		
    gnome_canvas_item_set(board_grid[x][y].pismeno,
	"x", (double) VEL_KAMENE-POFFX,
        "y", (double) VEL_KAMENE-POFFY,
        "font", KAMEN_FONT,
        "fill_color_rgba", text_barva,
        "text", p, 
        NULL);

    gnome_canvas_item_set(board_grid[x][y].hodnota,
        "x", (double) VEL_KAMENE-HOFFX,
        "y", (double) VEL_KAMENE-HOFFY,
        "font", HODNOTA_FONT,
        "fill_color_rgba", text_barva,
        "text", h, 
        NULL);

}/* end of board_draw_field() */

/* -------------------------------------------------------------------------- */

/* Vykresl desku (ji odehran kameny) */
GLOBAL void board_draw_loaded(void) {

    int i, j;
    char znak;
    char hodnota[10] = "";
    char pismeno[2] = "";

    for(i=1;i<=POC_KAMENU_SIRKA;i++)
	for(j=1;j<=POC_KAMENU_VYSKA;j++) {

	    znak = board[i][j].znak;

	    /* Vykresli neprzdn pole na desce */
	    if (znak != EMPTY_TILE) {
		
		pismeno[0] = toupper(board[i][j].znak); pismeno[1] = '\0';

		sprintf(hodnota, "%d", board[i][j].hodnota);
		
		board_draw_field(j-1, i-1, 
				 white_clr, black_clr, 
				 pismeno, hodnota);

	    }/* end if */

	}/* end for(j) */

}/* end of board_draw_loaded() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_deska.c */
