#include<ctype.h>
#include<stdlib.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "cross.h"
#include "vacek.h"
#include "prihradka.h"
#include "deska.h"
#include "skore.h"
#include "tahy_gui.h"
#include "gui_okno.h"
#include "gui_statusbar.h"
#include "gui_deska.h"
#include "gui_ovladace.h"
#include "tahy_seznam.h"
#include "tahy_gen.h"
#include "hra.h"
#include "util.h"

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

LOCAL gchar *nazev_souboru;
LOCAL GtkWidget *file_box;
LOCAL FILE *SOUBOR;
    
LOCAL int Sirka, Vyska, Prihradka;
LOCAL int P1Skore, P2Skore, SadaPocet, Ukvacek, PocetTahu;
LOCAL unsigned char P1Delka, P2Delka, ExtSlovnik, SlovnikDelka, Pocitac;
LOCAL unsigned char AktHrac, ZacinalHrac, PassCnt;
LOCAL char P1Jmeno[MAX_ROZMER] = "";
LOCAL char P2Jmeno[MAX_ROZMER] = "";
LOCAL char Slovnik[DMAX] = "";
LOCAL ssezkamen zolici[MAX_ROZMER];	/* Kter msta zabarvit? (olci) */
LOCAL int zolici_pocet = 0;		/* Kolik olk obarvit? */

LOCAL char Sada_Kamenu_Str[2*DMAX] = "";

/* ---------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC --------------- */

GLOBAL void gui_load_game_callback(void);

/* ----------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC --------------- */

LOCAL void game_load_proved_nahrani(GtkFileSelection *vyber, gpointer data);
LOCAL void game_load_ziskej_sadu_kamenu(void);
LOCAL void game_load_nacti_tah(int hrac, int tah);
LOCAL void game_load_nacti_vymenu(int hrac, int tah);
LOCAL void game_load_nacti_pass(int hrac, int tah);
LOCAL void game_load_nacti_odpis(int hrac, int tah);
LOCAL char game_load_spravne_nastaveni(void);
LOCAL void game_load_zobraz_odlisnosti(char stav);
LOCAL void game_load_nastav_ulozenou_hru(void);

/* ---------------------- DEFINICE GLOBALNCH FUNKC ------------------------ */

/* Oteve dialog pro uloen souboru se stavem hry */
GLOBAL void gui_load_game_callback(void) {


    file_box = gtk_file_selection_new("Nati stav hry.");
    gtk_file_selection_complete(GTK_FILE_SELECTION(file_box), ".sca");
    gtk_signal_connect(
	    GTK_OBJECT(GTK_FILE_SELECTION(file_box)->ok_button),
		      "clicked", GTK_SIGNAL_FUNC(game_load_proved_nahrani),
		      (gpointer) file_box);
	       
    gtk_signal_connect_object(
	    GTK_OBJECT(GTK_FILE_SELECTION(file_box)->ok_button),
		      "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
		      (gpointer) file_box);

    gtk_signal_connect_object(
	    GTK_OBJECT(GTK_FILE_SELECTION(file_box)->cancel_button),
		      "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy),
		      (gpointer) file_box);

    gtk_widget_show(file_box);
    gtk_window_set_modal(GTK_WINDOW(file_box), TRUE);

}/* end gui_load_game() */

/* ----------------------- DEFINICE LOCALNCH FUNKC ------------------------ */

/* Zskej nzev souboru z file_selectoru */
LOCAL void game_load_proved_nahrani(GtkFileSelection *vyber, gpointer data) {

    int i, j;
    char znak;
    unsigned char byte, stav;
    char skore[10];
    char *t;
    int hrac;

    /* Nateme nejdleitj parametry a porovnme je s aktulnmi.
     * Pokud se neshoduj, nememe hru nast. Dvod: rozdln velikost
     * desky, jin sada psmen, jin slovnk..
    */
    
    nazev_souboru = 
	gtk_file_selection_get_filename(GTK_FILE_SELECTION(file_box));

    printf("Nzev souboru = '%s'\n", nazev_souboru);    
 
    /* Otestuj nzev souboru */
    if ( (util_soubor_ma_priponu(nazev_souboru, ".sca")) == FALSE ) {
	show_warning_window(GTK_WINDOW(app), 
			"Soubor nen souborem se stavem hry (.sca)!");
	return;
    }

    /* Vybafni okno, pokud dojde k chyb */
    if ( (SOUBOR = fopen(nazev_souboru, "rb")) == NULL ) {
	t = g_strconcat(
		"Soubor '", nazev_souboru, "' se nepodailo otevt\n", NULL);
	fprintf(stderr, "%s", t);
	show_warning_window(GTK_WINDOW(app), t);
	g_free((gpointer) t);
	return;
    }

    /* Njak optimalizace? */    
    if (setvbuf(SOUBOR, NULL, _IOFBF, 8192) != 0)
	fprintf(stderr, 
		"(gui_load.c) Chyba pi nastaven blokovho bufferovn!");

 
    /* ------ NAPLNME PROMNN ------- */ 
   
    fread(&Sirka, sizeof(Sirka), 1, SOUBOR);
    fread(&Vyska, sizeof(Vyska), 1, SOUBOR);
    fread(&Prihradka, sizeof(Prihradka), 1, SOUBOR);

    /* Byl stav hry uloen pro jin nastaven? */
    stav = game_load_spravne_nastaveni();
    if (stav != 0) {
	fclose(SOUBOR);
	game_load_zobraz_odlisnosti(stav);/* Zobraz, co je poteba nastavit */
	return;
    }

    /* Extern slovnk? */
    fread(&ExtSlovnik, sizeof(ExtSlovnik), 1, SOUBOR);

    /* Cesta k externmu slovnku */
    fread(&SlovnikDelka, sizeof(SlovnikDelka), 1, SOUBOR);
    fread(&Slovnik, SlovnikDelka*sizeof(Slovnik[0]), 1, SOUBOR);
    Slovnik[SlovnikDelka] = '\0';
   
    /* Existuje soubor se slovnkem? */
    if ( (util_soubor_existuje(Slovnik) == FALSE) && (ExtSlovnik) ) {
	t = g_strconcat(
	"Soubor '", Slovnik, "' se slovnkem se nepodailo otevt!\n", NULL);
	fclose(SOUBOR);
	show_warning_window(GTK_WINDOW(file_box), t);
	g_free((gpointer) t);
	return;
    }

    /* Nati jmna hr a nastav je v 'textentries' */
    fread(&P1Delka, sizeof(P1Delka), 1, SOUBOR);
    fread(&P1Jmeno, P1Delka*sizeof(P1Jmeno[0]), 1, SOUBOR);
    P1Jmeno[P1Delka] = '\0';
    gtk_entry_set_text(GTK_ENTRY(player1_name), P1Jmeno);
    fread(&P2Delka, sizeof(P2Delka), 1, SOUBOR);
    fread(&P2Jmeno, P2Delka*sizeof(P2Jmeno[0]), 1, SOUBOR);
    P2Jmeno[P2Delka] = '\0';
    gtk_entry_set_text(GTK_ENTRY(player2_name), P2Jmeno);

    /* Nati skore a nacpi to do text. polek */
    fread(&P1Skore, sizeof(P1Skore), 1, SOUBOR);
    sprintf(skore, "%d", P1Skore);
    gtk_entry_set_text(GTK_ENTRY(player1_score), skore);
    fread(&P2Skore, sizeof(P2Skore), 1, SOUBOR);
    sprintf(skore, "%d", P2Skore);
    gtk_entry_set_text(GTK_ENTRY(player2_score), skore);
    

    fread(&SadaPocet, sizeof(SadaPocet), 1, SOUBOR);
   
    /* Naplnme veledleitou strukturu */ 
    for(i=0;i<SadaPocet;i++) {
	/* Znak, Hodnota */
	fread(&znak, sizeof(znak), 1, SOUBOR);
	fread(&j, sizeof(j), 1, SOUBOR);
	sada_kamenu[i].znak = znak;
	sada_kamenu[i].hodnota = j;
    }

    game_load_ziskej_sadu_kamenu();	 /* Ve tvaru 'pismeno,body,pocet;' */

    /* Pole nhodnch index */
    for(i=0;i<SadaPocet;i++) {
	/* Poradi, Menitelny */
	fread(&j, sizeof(j), 1, SOUBOR);
	fread(&byte, sizeof(byte), 1, SOUBOR);
	vacek[i].poradi = j;
	vacek[i].menitelny = byte;
    }

    /* Pozice v sad index */
    fread(&Ukvacek, sizeof(Ukvacek), 1, SOUBOR); 
    vacek_nastav_pozici_ve_vacku(Ukvacek);

    /* Kter hr je pota? */
    fread(&Pocitac, sizeof(Pocitac), 1, SOUBOR);

    /* Kter hr je aktuln? */
    fread(&AktHrac, sizeof(AktHrac), 1, SOUBOR);
    player = AktHrac;

    /* Kter hr zanal? */
    fread(&ZacinalHrac, sizeof(ZacinalHrac), 1, SOUBOR);

    /* Poet provedench nslednch PASS */
    fread(&PassCnt, sizeof(PassCnt), 1, SOUBOR);
  
    /* Desku si proistme (bugfix) */ 
    for(i=0;i<MAX_ROZMER;i++)
       for(j=0;j<MAX_ROZMER;j++) {
	   board[i][j].znak = EMPTY_TILE;
	   board[i][j].hodnota = EMPTY_TILE;
       }

    zolici_pocet = 0;
    /* Nemme dn olky */
    for(i=0;i<MAX_ROZMER;i++) 
	zolici[i].z = EMPTY_TILE;
	    	   
    /* Naplnme hrac desku */    
    for(i=1;i<=Sirka;i++) 
	for(j=1;j<=Vyska;j++) {
	    fread(&board[i][j].znak, sizeof(znak), 1, SOUBOR);
	    fread(&board[i][j].hodnota, sizeof(j), 1, SOUBOR);
	}


    for(i=0;i<MAX_ROZMER;i++) { 

        /* Abychom pi generovn tah "nevyskoili" mimo desku */

        /* dek 0 pro HOR/VER */
        (cross[0][i])[0].lo = 0; (cross[0][i])[0].hi = 0;
        (cross[0][i])[1].lo = 0; (cross[0][i])[1].hi = 0;

        /* sloupec 0 pro HOR/VER */     
        (cross[i][0])[0].lo = 0; (cross[i][0])[0].hi = 0;
        (cross[i][0])[1].lo = 0; (cross[i][0])[1].hi = 0;
        
        /* sloupec SIRKA+1 pro HOR/VER */
        (cross[i][POC_KAMENU_SIRKA+1])[0].lo = 0; 
        (cross[i][POC_KAMENU_SIRKA+1])[0].hi = 0;
        (cross[i][POC_KAMENU_SIRKA+1])[1].lo = 0; 
        (cross[i][POC_KAMENU_SIRKA+1])[1].hi = 0;

        /* radek VYSKA+1 pro HOR/VER */
        (cross[POC_KAMENU_VYSKA+1][i])[0].lo = 0; 
        (cross[POC_KAMENU_VYSKA+1][i])[0].hi = 0;
        (cross[POC_KAMENU_VYSKA+1][i])[1].lo = 0; 
        (cross[POC_KAMENU_VYSKA+1][i])[1].hi = 0;

    }/* end for */


    /* Cross-set mnoiny (Sirka x Vyska x 2 (orientace) x 8 (2 inty)) */
    /* Pro klasick Scrabble = 15 * 15 * 2 * 8 = 3600 Bytes */
    for(i=1;i<=POC_KAMENU_SIRKA;i++)
        for(j=1;j<=POC_KAMENU_VYSKA;j++) {
            fread(&cross[i][j][ZD].lo, sizeof(cross[i][j][ZD].lo), 1, SOUBOR);
            fread(&cross[i][j][ZD].hi, sizeof(cross[i][j][ZD].hi), 1, SOUBOR);
            fread(&cross[i][j][SD].lo, sizeof(cross[i][j][SD].lo), 1, SOUBOR);
            fread(&cross[i][j][SD].hi, sizeof(cross[i][j][SD].hi), 1, SOUBOR);
        }/* end for (j) */


    /* Resetuj skore */
    for(i=0;i<MAX_ROZMER;i++)
        for(j=0;j<MAX_ROZMER;j++) {
            score[i][j][ZD] = 0; score[i][j][SD] = 0;   /* dn skre */
        }

    /* Struktury pro vpoet skore */
    /* Pro klasick Scrabble = 15 * 15 * 2 * 4 = 1800 Bytes */
    for(i=1;i<=POC_KAMENU_SIRKA;i++) 
        for(j=1;j<=POC_KAMENU_VYSKA;j++) {
	    fread(&score[i][j][ZD], sizeof(score[i][j][ZD]), 1, SOUBOR);
	    fread(&score[i][j][SD], sizeof(score[i][j][SD]), 1, SOUBOR);
        }/* end for (j) */

    /* Psmenn bonusy - pole char */
    /* Pro klasick Scrabble = 15 * 15 * 1 = 225 Bytes */
    for(i=1;i<=POC_KAMENU_SIRKA;i++)
        for(j=1;j<=POC_KAMENU_VYSKA;j++) {
	    fread(&pismmult[i][j], sizeof(pismmult[i][j]), 1, SOUBOR);
        }

    /* Slovn bonusy - pole char */
    /* Pro klasick Scrabble = 15 * 15 * 1 = 225 Bytes */
    for(i=1;i<=POC_KAMENU_SIRKA;i++) 
        for(j=1;j<=POC_KAMENU_VYSKA;j++) {
	    fread(&slovmult[i][j], sizeof(slovmult[i][j]), 1, SOUBOR);
        }


    /* Zjisti poet tah, budeme plnit clist */
    fread(&PocetTahu, sizeof(PocetTahu), 1, SOUBOR);
    printf("LOAD Pocet tahu = %d\n", PocetTahu);


    /* Naplnme prbh pedchoz hry */
    gtk_clist_clear(GTK_CLIST(prubeh_clist));
    
    i = prubeh_kolik = 0; hrac = ZacinalHrac;
    while (i<PocetTahu) {

	/* Zskej typTAHu */
	fread(&znak, sizeof(znak), 1, SOUBOR);

	switch(znak) {
	    case 'h':	game_load_nacti_tah(hrac, i+1);    break;
	    case 'v':	game_load_nacti_vymenu(hrac, i+1); break;
	    case 'p':   game_load_nacti_pass(hrac, i+1);   break;
	    case 'o':	game_load_nacti_odpis(hrac, i+1);  break;
	}/* end switch */

	i++;
	hrac ^= 1;	/* 0-=>1 1-=>0 */

    }/* end while */

    gtk_clist_moveto(GTK_CLIST(prubeh_clist), PocetTahu, 0, 0, 0);
    
    /* Hotovo */
    fclose(SOUBOR);


    /* Nati sprvn slovnk, vykresli board, povol ve, co je poteba */
    game_load_nastav_ulozenou_hru();
	
#ifdef LOAD_DEBUG
    printf("Sirka = %d, Vyska = %d\n", Sirka, Vyska);    
    printf("Prihradka = %d\n", Prihradka);
    printf("Jmno hre1 = '%s'\n", P1Jmeno);
    printf("Jmno hre2 = '%s'\n", P2Jmeno);
    printf("Skore1 = %d, Skore2 = %d\n", P1Skore, P2Skore);
    printf("SadaPocet = %d\n", SadaPocet);
    for(i=0;i<SadaPocet;i++) {
	printf("[%c,%d],", sada_kamenu[i].znak, sada_kamenu[i].hodnota);
    }
    printf("\n-------------------------------------------\n");
    for(i=0;i<SadaPocet;i++) {
	printf("[%d,%d],", vacek[i].poradi, vacek[i].menitelny);
    }
    printf("\n-------------------------------------------\n");

    printf("Ukvacek = %d\n", Ukvacek);
    printf("Extern slovnk = %d\n", ExtSlovnik);
    printf("Cesta ke slovnku = '%s'\n", Slovnik);
    printf("Pota = %d\n", Pocitac);
    printf("Aktuln hr = %d\n", AktHrac);
    
    for(i=1;i<=Sirka;i++) {
	for(j=1;j<=Vyska;j++) {
	    printf("%c", 
		    (board[i][j].znak != EMPTY_TILE) ? board[i][j].znak : '0');
	}
	printf("\n");
    }

    printf("Pocet tahu = %d\n", PocetTahu);
    printf("Sada_Kamenu_Str = '%s'\n",  Sada_Kamenu_Str);
#endif
    
}/* end of game_load_proved_ulozeni() */

/* -------------------------------------------------------------------------- */

/* Nate informace o provedenm tahu : slovo, body, souradnice.... */
LOCAL void game_load_nacti_tah(int hrac, int tah) {

    unsigned char o, x, y, d;
    int i, body;
    tpozice poz;
    torientace ori;
    char znak;
    char slovo[MAX_ROZMER] = "";
    char *radek[5];
    char bod[10] = "";
    char sou[10] = "";
    char stah[5] = "";
    char s[5] = "";

    sprintf(stah, "%d", tah);
    radek[0] = stah;

    if (hrac == 0)
	radek[1] = P1Jmeno;
    else
	radek[1] = P2Jmeno;
    
    /* Orientace, X, Y, Body, Slovo */
    fread(&o, sizeof(o), 1, SOUBOR);
    fread(&x, sizeof(x), 1, SOUBOR);
    fread(&y, sizeof(y), 1, SOUBOR);
    
    if (o == HORIZONTAL) { /* 15H */
	sprintf(s, "%d", x);
	strcat(sou, s);
	s[0] = (char) y + 'A' - 1;
	s[1] = '\0';
	strcat(sou, s);
    }
    else {		   /* H15 */
	s[0] = x + 'A' - 1;
	s[1] = '\0';
	strcat(sou, s);
	sprintf(s, "%d", y);
	strcat(sou, s);
    }
    radek[3] = sou;

    fread(&body, sizeof(body), 1, SOUBOR);
    sprintf(bod, "%d", body);
    radek[2] = bod;
    
    fread(&d, sizeof(d), 1, SOUBOR);
    fread(&slovo, d*sizeof(slovo[0]), 1, SOUBOR);
    slovo[d] = '\0';

    /* Pokud byl vyuit olk, zjistme, kter psmeno to je */

    /* do x, y dme potek slova a nastavme sprvn orientaci */
    poz.x = (o == HORIZONTAL) ? x : y;
    poz.y = (o == HORIZONTAL) ? y : x;
    ori = (o == HORIZONTAL) ? ZD : SD;
    
    i = 0;
    while (i<strlen(slovo)) {

	znak = slovo[i++];

	/* Mme olka! */
	if (znak == '*') {
	    zolici[zolici_pocet].z = slovo[i++];
	    zolici[zolici_pocet].x = poz.x;
	    zolici[zolici_pocet].y = poz.y;
	    zolici[zolici_pocet++].h = board[poz.x][poz.y].hodnota;
	    printf("ukladam zolika [%c,%d,%d,%d]\n", 
		    zolici[zolici_pocet-1].z,
		    zolici[zolici_pocet-1].x,
		    zolici[zolici_pocet-1].y,
		    zolici[zolici_pocet-1].h);
	}/* end if */

	poz = ZA(poz, ori);
	
    }/* end while */

    radek[4] = slovo;

    gtk_clist_append(GTK_CLIST(prubeh_clist), radek);

    prubeh_typ[prubeh_kolik++] = 'h';       /* ode'h'rlo se */
	  

}/* end of game_load_nacti_tah() */

/* -------------------------------------------------------------------------- */

/* Zsk informace po potu vymnnch kamenech */
LOCAL void game_load_nacti_vymenu(int hrac, int tah) {

    unsigned char byte;
    char bod[5] = "---";
    char sou[5] = "---";
    char kolik[5] = "";
    char stah[5] = "";
    char slovo[] = "VMNA(";
    char *radek[5];
    char *s;

    sprintf(stah, "%d", tah);
    radek[0] = stah;

    if (hrac == 0)
	radek[1] = P1Jmeno;
    else
	radek[1] = P2Jmeno;

    radek[2] = bod;
    radek[3] = sou;

    fread(&byte, sizeof(byte), 1, SOUBOR);
    sprintf(kolik, "%d", byte);
    s = g_strconcat(slovo, kolik, ")", NULL);
    radek[4] = s;

    gtk_clist_append(GTK_CLIST(prubeh_clist), radek);

    g_free((gpointer) s);

    prubeh_typ[prubeh_kolik++] = 'v';

}/* end of game_load_nacti_vymenu() */

/* -------------------------------------------------------------------------- */

/* Vype 'Pass' :-) */
LOCAL void game_load_nacti_pass(int hrac, int tah) {

    char bod[5] = "---";
    char sou[5] = "---";
    char stah[5] = "";
    char slovo[] = "PASS";
    char *radek[5];

    sprintf(stah, "%d", tah);
    radek[0] = stah;

    if (hrac == 0)
	radek[1] = P1Jmeno;
    else
	radek[1] = P2Jmeno;

    radek[2] = bod;
    radek[3] = sou;
    radek[4] = slovo;

    gtk_clist_append(GTK_CLIST(prubeh_clist), radek);

    prubeh_typ[prubeh_kolik++] = 'p';       /* 'p'ass */
    
}/* end of game_load_nacti_pass() */

/* -------------------------------------------------------------------------- */

/* Nate info o 'odpisu' skore */
LOCAL void game_load_nacti_odpis(int hrac, int tah) {

    int i;
    unsigned char byte;

    char bod[5] = "";
    char sou[5] = "---";
    char stah[5] = "";
    char slovo[] = "odpis";
    char *radek[5];

    sprintf(stah, "%d", tah);
    radek[0] = stah;

    if (hrac == 0)
	radek[1] = P1Jmeno;
    else
	radek[1] = P2Jmeno;

    fread(&byte, sizeof(byte), 1, SOUBOR);
    fread(&i, sizeof(i), 1, SOUBOR);

    sprintf(bod, "%d", i);
    radek[2] = bod;
    radek[3] = sou;
    radek[4] = slovo;

    gtk_clist_append(GTK_CLIST(prubeh_clist), radek);

    prubeh_typ[prubeh_kolik++] = 'o';       /* 'o'dpis ze skore */
    
}/* end of game_load_nacti_odpis() */

/* -------------------------------------------------------------------------- */

/* Napln Sada_Kamenu_Str sadou psmen 'p,b,p' [pismeno,body,pocet] */
LOCAL void game_load_ziskej_sadu_kamenu() {

    char znak;
    char *s = NULL;
    char pis[2] = "";
    char bod[5] = "";
    char poc[5] = "";
    int body;
    int i, j;

    i = 0; j = 1;
    znak = sada_kamenu[i].znak; 
    body = sada_kamenu[i++].hodnota;
    
    while(i<SadaPocet) {

	while(znak == sada_kamenu[i].znak) { j++; i++; }
        pis[0] = znak; pis[1] = '\0';
        sprintf(bod, "%d", body);
        sprintf(poc, "%d", j);

        s = g_strconcat(pis, ",", bod, ",", poc, ";", NULL);
        strcat(Sada_Kamenu_Str, s);
        g_free((gpointer) s);

        znak = sada_kamenu[i].znak;
        body = sada_kamenu[i].hodnota;

        j = 0;  /* Alespon jeden u je */

    }/* end while */

}/* end of game_load_ziskej_sadu_kamenu() */

/* -------------------------------------------------------------------------- */

/* Vrac nenulovou hodnotu, pokud je nkter z kritickch nastaven odlin od
 * prv pouvanch. Konkrtn pak:
 * 1) ka + Vka desky
 * 2) Poet kamen v pihrdce 
 * 3) Slovnk
*/
LOCAL char game_load_spravne_nastaveni(void) {

    char result = 0;
    const char GSirka = 1;	/* Li se ka */
    const char GVyska = 2;      /* Dtto vka */
    const char GMRack = 4;	/* Jin poet kamen v pihrdce */
    
    if (Sirka != POC_KAMENU_SIRKA)
	result |= GSirka;
    if (Vyska != POC_KAMENU_VYSKA)
	result |= GVyska;
    if (Prihradka != MAX_PISMEN_PRIHRADKA)
	result |= GMRack;

    return(result);

}/* end of game_load_spravne_nastaveni() */

/* -------------------------------------------------------------------------- */

/* Zobraz okno a v nm info, co nastavit, aby el stav hry nahrt */
LOCAL void game_load_zobraz_odlisnosti(char stav) {

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *hsep;
    int button;
    char s[5];
    char t[5];
    char *text;

    dialog = 
    gnome_message_box_new("Odlin konfigurace.\n"
            "Aktuln konfigurace se li od konfigurace uloenho stavu.",
             GNOME_MESSAGE_BOX_ERROR, "OK", NULL);

    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(file_box));
    gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);

    label = gtk_label_new(
	    "\nProvete zmnu aktuln konfigurace pro naten stavu hry.\n");
    gtk_box_pack_start(
        GTK_BOX(GNOME_DIALOG(dialog)->vbox), label, FALSE, FALSE, 0);

    hsep = gtk_hseparator_new();
    gtk_box_pack_start(
	    GTK_BOX(GNOME_DIALOG(dialog)->vbox), hsep, FALSE, FALSE, 0);

    if (stav & 1) {
	sprintf(s, "%d", POC_KAMENU_SIRKA);
	sprintf(t, "%d", Sirka);
	text = g_strconcat(
	"Aktuln ka desky: ", s, "        Uloen ka desky: ", t, NULL);
	label = gtk_label_new(text);
	gtk_box_pack_start(
	        GTK_BOX(GNOME_DIALOG(dialog)->vbox), label, FALSE, FALSE, 0);
	g_free((gpointer) text);
    }
    if (stav & 2) {
	sprintf(s, "%d", POC_KAMENU_VYSKA);
	sprintf(t, "%d", Vyska);
	text = g_strconcat(
	"Aktuln vka desky: ", s, "        Uloen vka desky: ", t, NULL);
	label = gtk_label_new(text);
	gtk_box_pack_start(
	        GTK_BOX(GNOME_DIALOG(dialog)->vbox), label, FALSE, FALSE, 0);
	g_free((gpointer) text);
    }
    if (stav & 4) {
	sprintf(s, "%d", MAX_PISMEN_PRIHRADKA);
	sprintf(t, "%d", Prihradka);
	text = g_strconcat(
	"Aktuln rozmr pihrdky: ",s, "        Uloen rozmr pihrdky: ", t, NULL);
	label = gtk_label_new(text);
	gtk_box_pack_start(
	        GTK_BOX(GNOME_DIALOG(dialog)->vbox), label, FALSE, FALSE, 0);
	g_free((gpointer) text);
    }

    gtk_widget_show_all(dialog);

    button = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

}/* end of game_load_zobraz_odlisnosti() */

/* -------------------------------------------------------------------------- */

/* Nastav vechno potebn k tomu, abychom mohli pokraovat ve he */
LOCAL void game_load_nastav_ulozenou_hru(void) {

    int x, y;
    char pism[5];
    char hodn[10];

    /* Aktuln a zanajc hr */
    player = AktHrac;
    hra_nastav_zacinal_hrac(ZacinalHrac);

    /* slo aktulnho tahu */
    turn = PocetTahu+1;

    /* Je poteba ukldat na stedov pole? */
    if (turn == 1)
	mid_wanted = TRUE;
    else
	mid_wanted = FALSE;

    /* Poet pass */
    pass_count = PassCnt;

    /* Skore */
    skore_h1 = P1Skore;
    skore_h2 = P2Skore;

    /* Hrajeme */
    game_mode = PLAY_MODE;

    /* Vytvo sada_cetnosti[] pole */
    vacek_inicializace_po_load(SadaPocet, Sada_Kamenu_Str);

    prubeh_nastav_index(PocetTahu);

    /* Na desce nebude nic uloeno */
    for (x=0; x<MAX_PISMEN_PRIHRADKA; x++) {
        rack_click[x] = FALSE;               /* kmen nen oznaen ke he */
        rack_set_placed_on_board(x, FALSE)  ;/* kmen je v racku, ne na desce */
        rack_placed_tiles_coords[x].x = EMPTY_TILE; 
        /* x - nen umstn na desce = -1 */
        rack_placed_tiles_coords[x].y = EMPTY_TILE; 
        /* y - nen umstn na desce = -1 */
        rack_placed_tiles_coords[x].which = EMPTY_TILE;      
        /* dn psmeno z racku */
    }/* end for pro rack */

    /* dn tahy nenalezeny, nutno aktualizovat */
    tahy_seznam_uvolni();
    gtk_clist_clear(GTK_CLIST(pomoc_clist));

    board_set_tile_clicked(FALSE);               /* Pepna pro vbr kamene */

    /* Tlatka mohou pijmat udlosti, hra zan */ 
    gtk_widget_set_sensitive(GTK_WIDGET(done_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(pass_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(change_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(evaluate_button), TRUE);

    /* Nelze nastavit jmno hre */
    gtk_entry_set_editable(GTK_ENTRY(player1_name), FALSE);
    gtk_entry_set_editable(GTK_ENTRY(player2_name), FALSE);
    
    /* Checboxy pro vbr potae nesm fungovat */
    gtk_widget_set_sensitive(GTK_WIDGET(cbox1), FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(cbox2), FALSE);
	    

    /* Nastav sprvn sla tah, hre */
    gui_statusbar_zobraz_tah();
    gui_statusbar_zobraz_hrace();
    gui_statusbar_zobraz_zbytek();
    


    /* Vyisti board, umsovat, budeme za chvli */
    for(x=0;x<POC_KAMENU_SIRKA;x++)
        for(y=0;y<POC_KAMENU_VYSKA;y++)
            board_revert_tile_to_empty(y, x);


    /* Zobraz odehran kameny na desce */
    board_draw_loaded();

    /* Postarme se o zvraznn olk */
    for(x=0;x<zolici_pocet;x++) {
	pism[0] = toupper(zolici[x].z); pism[1] = '\0';
	sprintf(hodn, "%d", zolici[x].h);
	board_draw_field(zolici[x].y-1, zolici[x].x-1, 
		         white_clr, red_clr,
			 pism, hodn);
    }/* end for (x) */

#ifdef LOAD_DEBUG
    for(x=1;x<=POC_KAMENU_SIRKA;x++) {
	for(y=1;y<=POC_KAMENU_VYSKA;y++) {
	    printf("%c", 
		    (board[x][y].znak != EMPTY_TILE) ? board[x][y].znak : '0');
	}
	printf("\n");
    }
#endif
    
    /* Vykresli rack aktulnho hre */    
    draw_rack();

    /* Umonme zobrazen nalezench tah v oknku s tahy */
    set_help_handler_counter(EMPTY_TILE);

    /* Umonme hledn tah */
    if (mid_wanted == TRUE)
	tahy_generuj_prvni_tah();
    else
	tahy_generuj_tah();
    
	
}/* end of game_load_nastav_ulozenou_hru() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_load.c */
