#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "gui_okno.h"
#include "hra.h"

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void gui_rekord_zobraz(void);

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* Zobraz jednoduch okno se jmnem hre a
 * rekordem, kterho bylo zatm dosaeno.
*/
GLOBAL void gui_rekord_zobraz(void) {

    char *ukazatel = NULL;
    int rekord = 0;
    char skore[MAX_ROZMER];
    char jmeno[MAX_ROZMER];

    GtkWidget *dialog;
    GtkWidget *label;

    if (game_mode == CHANGE_MODE)
	return;

    dialog = gnome_dialog_new(_("Zobrazen rekordu."), 
                                GNOME_STOCK_BUTTON_OK, NULL);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), FALSE);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);

    /* Zskej max. dosaen skre */
    gnome_config_push_prefix(SkorePrefix);
    rekord = gnome_config_get_int("MAX_SKORE=0");
    sprintf(skore, "%d", rekord);
    ukazatel = gnome_config_get_string("MAX_SKORE_JMENO=Pan Tau");
    strcpy(jmeno, ukazatel);
    g_free((gpointer)ukazatel);
    gnome_config_pop_prefix();

    ukazatel = NULL;
    ukazatel = g_strconcat("Nejvy dosaen skre: ", skore,
			    "\nRekord vytvoil hr: ", jmeno, NULL);
    label = gtk_label_new(ukazatel);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                     label, TRUE, TRUE, GNOME_PAD);
    g_free((gpointer) ukazatel);

    gtk_widget_show_all(dialog);

    gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

}/* end of gui_rekord_zobraz() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_rekord.c */
