#include<stdlib.h>
#include<glib.h>
#include<string.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#ifndef PUBLIC_VERSION
#include "alib.h"
#endif
#include "config.h"
#include "gui_okno.h"
#include "gui_deska.h"
#include "vyznamy.h"
#include "cesty.h"

/* ------------------------ DEFINICE LOCALNCH TYP ------------------------- */

/* --------------------- DEKLARACE GLOBALNCH PROMNNCH -------------------- */

/* --------------------- DEKLARACE LOCALNCH PROMNNCH --------------------- */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void gui_vyznamy_zobraz_okno(void);

/* --------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */
	
LOCAL void gui_vyznamy_zobraz_vyznamy(GtkWindow *okno, char *slovo);
LOCAL void gui_vyznamy_formatuj(GtkWidget *text, char *vyznam);
#ifndef PUBLIC_VERSION
LOCAL void gui_vyznamy_vystup_ajky(char *slovo,GtkWidget *text, GdkColor barva);
LOCAL void gui_vyznamy_ajka_info(GtkWidget *text, char *znacka, char druh);
LOCAL void gui_vyznamy_nahrada(char *slovo, char co_znak, char cim_znak);
#endif

/* -------------------- DEFINICE JEDNOTLIVCH FUNKC ------------------------ */

/* Zobraz okno s textentry pro vloen slova */
GLOBAL void gui_vyznamy_zobraz_okno(void) {

    GtkWidget *dialog;
    GtkWidget *label;
    GtkWidget *textentry;
    int reply;
    char slovo[MAX_ROZMER+1];

  
    dialog = gnome_dialog_new(N_("Vznam slova"), 
				GNOME_STOCK_BUTTON_OK,
				GNOME_STOCK_BUTTON_CANCEL,
				NULL);
  
    gnome_dialog_set_close(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), TRUE);
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_set_parent(GNOME_DIALOG (dialog), GTK_WINDOW(app));

    label = gtk_label_new("Vznam slova");
    textentry = gtk_entry_new_with_max_length(MAX_ROZMER);

    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
		       label, TRUE, TRUE, GNOME_PAD);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                       textentry, TRUE, TRUE, GNOME_PAD);
    gnome_dialog_editable_enters(GNOME_DIALOG(dialog), GTK_EDITABLE(textentry));
    gtk_widget_grab_focus(textentry);
  
    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run(GNOME_DIALOG(dialog));
  
    if (reply == GNOME_OK) {      

	strcpy(slovo, gtk_entry_get_text(GTK_ENTRY(textentry)));

	/* Je-li to przdn dek */
	if (strcmp(slovo, "") == 0)
	    return;
      
	/* Mezera nen taky povolena */
	if ( (strchr(slovo, (int) ' ')) != NULL ) {
	    show_warning_window(GTK_WINDOW(dialog), 
            "Slovo nesm obsahovat mezeru!");
	    return;
	}

	/* Zobraz dal okno s vznamy */
	gui_vyznamy_zobraz_vyznamy(GTK_WINDOW(dialog), slovo);

    }/* end if */

    gtk_widget_destroy(dialog);   

}/* end of gui_vyznamy_zobraz_okno() */

/* -------------------------------------------------------------------------- */

#ifndef PUBLIC_VERSION
/* Provede nhradu znaku 'co_znak' znakem 'cim_znak' ve 'slovo'. */
LOCAL void gui_vyznamy_nahrada(char *slovo, char co_znak, char cim_znak) {

    int i;

    for(i=0;i<strlen(slovo);i++)
	if (slovo[i] == co_znak)
	    slovo[i] = cim_znak;

}/* end of gui_vyznamy_nahrada() */

/* -------------------------------------------------------------------------- */

/* Pipe k danmu slovu mluvnick kategorie (projde znaku a vype
 * vznam kad dvojice (bez prvn [kX]).
*/
LOCAL void gui_vyznamy_ajka_info(GtkWidget *text, char *znacka, char druh) {

    int i;
    char klic[3];
    char *vyznam;

    /* Pro odlien kl v hash tabulce je poteba
     * je odliit (nutno upravit znaky.
    */
    if (druh == '3')
	gui_vyznamy_nahrada(znacka, 'y', 'x');
    else if (druh == '4')
	gui_vyznamy_nahrada(znacka, 'x', 'y');
    else if (druh == '6') {
	gui_vyznamy_nahrada(znacka, 'x', 'z');
	gui_vyznamy_nahrada(znacka, 'y', 'z');
    }
    else if (druh == '8')
	gui_vyznamy_nahrada(znacka, 'x', 'q');

    /* Pro tyto slovn druhy urit nebude nic vc ne kX */
    if (druh == '9' || druh == '0' || druh == 'A' || strlen(znacka) == 2) {
	/* oddkujeme pouze */	
	gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, 
	    NULL, "\n", -1);
	return;
    }

    gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, 
	NULL, " --- ", -1);

    /* znaky 0,1 jsou 'kX', to nechceme */
    i = 2;     

    while (i<strlen(znacka)) {
	
	/* Vytvome kl do hash tabulky */
	klic[0] = znacka[i++];
	klic[1] = znacka[i++];
	klic[2] = '\0';

	if ( (vyznam=vyznamy_ajka_dej_vyznam(klic)) != NULL ) {
	    gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, 
		    NULL, vyznam, -1);
	    gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, 
		    NULL, ", ", -1);
	}
	
    }/* end while */

    gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, 
	NULL, "\n", -1);
    
}/* end of gui_vyznamy_ajka_info() */

/* -------------------------------------------------------------------------- */

/* Zavol ajku a vype informaci ke kadmu homonymu */
LOCAL void gui_vyznamy_vystup_ajky(char *slovo, GtkWidget *text, GdkColor barva){

    GdkColor zelena;   
    GdkColor modra;   
   
    char *vyznam; 
    void *p_morf;
    unsigned char lopt=0;
    int nmor = 0; 
    char lemm[50], tags[1024], znacka[50];
    char slovni_druh[3] = "kX\0";
    int i;
    int ntag; 

    zelena.red = 0;
    zelena.green = 0x8888;
    zelena.blue = 0;

    modra.red = 0;
    modra.green = 0;
    modra.blue = 0x8888;

    /* Inicializace ajky */
    if(ajka_InitWrk(AJKA_MRF, AJKA_STM, &p_morf)) {
        fprintf(stderr, "gui_vyznamy.c: ajka_InitWrk selhalo!\n");
        return;
    }

    /* nmor obsahuje poet homonym - ta budou vypsna */
    if ((nmor = ajka_ChkWord(slovo,p_morf))) {

	/* Kad homonymum vypeme spolu s informacemi o nm */
        for(i=0; i<nmor; i++) {

    	    /* Napl pole 'lemm' zkladnm tvarem slova */
	    ajka_GetLemm(i, lopt, lemm, p_morf);

	    /* Popeme jen 1. znaku ze seznamu!!! */
	    /* Seznam znaek bude v 'tags[]' */
            ntag = ajka_GetGTag(i, tags, p_morf);

	    slovni_druh[1] = tags[1];
	    /* tags je pole char, kde je obas i '\0' */
	    /* zkopruje se jenom prvn znaka vetn '\0' */
	    strcpy(znacka, tags);

	    /* Vypeme 'tvar [slovnho_druhu]' */
    	    gtk_text_insert(GTK_TEXT(text), NULL, 
		&text->style->black, NULL, "tvar ", -1);
	    if ( (vyznam=vyznamy_ajka_dej_vyznam(slovni_druh)) != NULL )
	    gtk_text_insert (GTK_TEXT (text), NULL, 
		    &modra, NULL, vyznam, -1);
    	    gtk_text_insert(GTK_TEXT(text), NULL, 
		&text->style->black, NULL, " ", -1);
    	    gtk_text_insert(GTK_TEXT(text), NULL, 
		&zelena, NULL, lemm, -1);

	    /* A k nmu informace */
	    gui_vyznamy_ajka_info(text, znacka, slovni_druh[1]);

       }/* for (i<nmor ...) */

    }/* end if nmor SLOVO EXISTUJE */
    else {
	gtk_text_insert(GTK_TEXT(text), NULL, 
	    &barva, NULL, "-- ajka slovo nezn!\n", -1);
    }

    ajka_ExitWrk(p_morf); 

}/* end of gui_vyznamy_vystup_ajky() */

#endif

/* -------------------------------------------------------------------------- */

/* Vezme vznamy ve tvaru 'vyznam1#vyznam2#vyznam3#' a vype je v okn
 * pod sebe s odrkou.
*/
LOCAL void gui_vyznamy_formatuj(GtkWidget *text, char *vyznam) {

    char popis[256] = "-";
    int i, j;
    
    i = 0;

    while (i<strlen(vyznam)) {
	
	j = 1; /* Chceme ten '-' na zatku */
	while (vyznam[i++] != '#')
	    popis[j++] = vyznam[i-1];

	popis[j++] = '\n'; popis[j] = '\0';
	
	gtk_text_insert(GTK_TEXT(text), NULL, 
	    &text->style->black, NULL, popis, -1);

    }/* end while */

}/* end of gui_vyznamy_formatuj() */

/* -------------------------------------------------------------------------- */

/* Zobraz v okn vznamy slova 'slovo' */
LOCAL void gui_vyznamy_zobraz_vyznamy(GtkWindow *okno, char *slovo) {

    GtkWidget *dialog;
    GtkWidget *scroll_okno;
    GtkWidget *text;

    GdkColor color;
    GdkFont *fixed_font;
    GdkFont *slovo_font;

    int reply;
    char *vyznam;
    char font[100] = "-adobe-helvetica-bold-r-normal--16-*-*-*-*-*-iso8859-2";
    char font2[100] = "-adobe-helvetica-bold-r-normal--16-*-*-*-*-*-iso8859-2";

    
    dialog = gnome_dialog_new("Vznam slova", GNOME_STOCK_BUTTON_OK, NULL); 
    gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(okno));
    gnome_dialog_set_default(GNOME_DIALOG(dialog), GNOME_OK);
    gnome_dialog_close_hides(GNOME_DIALOG(dialog), FALSE);
    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
   
   
    scroll_okno = gtk_scrolled_window_new (NULL, NULL);
    gtk_box_pack_start(GTK_BOX(GNOME_DIALOG(dialog)->vbox),
                       scroll_okno, FALSE, FALSE, 3);
    gtk_widget_set_usize(scroll_okno, 700, 395); 
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll_okno),
                                   GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
   
    text = gtk_text_new (NULL, NULL);
    gtk_text_set_editable (GTK_TEXT (text), FALSE);
    gtk_container_add(GTK_CONTAINER(scroll_okno), text);

    /* Get the system color map and allocate the color red */
    color.red = 0xFFFF;
    color.green = 0;
    color.blue = 0;

    fixed_font = gdk_font_load(font);
    slovo_font = gdk_font_load(font2);

    gtk_text_freeze (GTK_TEXT (text));

    gtk_text_insert (GTK_TEXT (text), fixed_font, &color, NULL,
                   "                        "
		   "Vznamy slova\n\n",
		   -1);
    
    gtk_text_insert (GTK_TEXT (text), slovo_font, &text->style->black, NULL,
		   slovo, -1);
#ifndef PUBLIC_VERSION
    gtk_text_insert (GTK_TEXT (text), fixed_font, &text->style->black, NULL,
                   "\n\n1) kovksk slovnk + \"Vetenk\":\n\n",
		   -1);
#else
    gtk_text_insert (GTK_TEXT (text), fixed_font, &text->style->black, NULL,
                   "\n\n1) Vznamov slovnk pana Vetenka:\n\n",
		   -1);
#endif
    
    if ( (vyznam=vyznamy_dej_vyznam(slovo)) == NULL )
	gtk_text_insert (GTK_TEXT (text), NULL, 
		&color, NULL, "-- vznam nebyl nalezen\n", -1);
    else
	gui_vyznamy_formatuj(text, vyznam); 

#ifndef PUBLIC_VERSION
    gtk_text_insert (GTK_TEXT (text), fixed_font, &text->style->black, NULL,
                   "\n2) morfologick analyztor ajka: \n\n",
		   -1);

    gui_vyznamy_vystup_ajky(slovo, text, color);
#endif

    gtk_text_thaw(GTK_TEXT(text));

    gdk_font_unref(fixed_font);
    gdk_font_unref(slovo_font);

    gtk_widget_show_all(dialog);

    reply = gnome_dialog_run_and_close(GNOME_DIALOG(dialog));

}/* end of gui_vyznamy_zobraz_vyznamy() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE gui_vyznamy.c */
