#include<stdlib.h>
#include<gnome.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "vacek.h"
#include "cross.h"
#include "gui_okno.h"
#include "gui_statusbar.h"
#include "gui_deska.h"
#include "gui_ovladace.h"
#include "gui_slovniky.h"
#include "gui_logovani.h"
#include "deska.h"
#include "tahy_gui.h"
#include "tahy_gen.h"
#include "tahy_seznam.h"
#include "skore.h"
#include "prihradka.h"
#include "logovani.h"
#include "konverze.h"
#include "hra.h"

/* ------------------ DEKLARACE GLOBLNCH PROMNNCH ----------------------- */

GLOBAL char nenalezeno[MAX_ROZMER+1];   /* Bude obsahovat chybn slovo */
GLOBAL char odehravane[MAX_ROZMER+1];   /* Bude obsahovat odehrvan slovo */
GLOBAL int player;                                    /* HRAC1 / HRAC2 */
GLOBAL boolean mid_wanted;                 /* Je teba umstit na 7,7? */
GLOBAL int game_mode;              /* Reim hry (PLAY_MODE/CHANGE_MODE) */
GLOBAL int turn;                   /* Tah */
GLOBAL char prubeh_typ[DMAX];                           /* typ tahu */
GLOBAL int prubeh_kolik;

GLOBAL unsigned char computer = 2; /* Kter hr je pota? 0/1/2=1/2/dn */
GLOBAL unsigned char pass_count;   /* Konec hry = 2x oba hri provedli PASS */
GLOBAL boolean ext_slovnik;	   /* Pouv se ext. slovnk? FALSE/TRUE */
GLOBAL char akt_slovnik_cesta[DMAX]; /* Pi ext_slovnik == 1 ukazuje cestu */	

/* -------------------- DEKLARACE LOCLNCH PROMNNCH ---------------------- */

LOCAL int zacinal_hrac;		/* Kter hr zanal? (0/1) */
LOCAL boolean povol_cheat = FALSE; /* Povolme tlatko 'Najdi slova'? */
				      

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL unsigned char hra_dej_zacinal_hrac(void);
GLOBAL  int hra_dej_poradi_tahu(void);
GLOBAL void hra_nastav_zacinal_hrac(int hrac);
GLOBAL void hra_nastav_podvadeni(boolean stav);
GLOBAL boolean hra_dej_stav_podvadeni(void);
GLOBAL void hra_nova_hra(void);
GLOBAL void hra_ukonci_hru(void);
GLOBAL void hra_proved_hru_pocitace(void);
GLOBAL void hra_proved_tah(void);
GLOBAL void hra_proved_vymenu(void);
GLOBAL void hra_proved_pass(void);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL void hra_urci_prvniho_hrace(void);
LOCAL void hra_inicializuj(void);
LOCAL void hra_prepni_hrace(void);
LOCAL void hra_konec_hry(int jak);
LOCAL void hra_proved_odpis(int komu);
LOCAL void hra_aktualizuj_pocitadla(void);
LOCAL int hra_proved_vymenu_pocitace(void);

/* -------------------------------------------------------------------------- */

/* Nhodn vygeneruje slo 0 nebo 1 a podle toho nastav 
 * hre, kter bude hru zanat. 
*/
LOCAL void hra_urci_prvniho_hrace(void) {

    srand((unsigned) time(NULL));

    zacinal_hrac = rand() % 2;	/* Chceme jen 0 nebo 1 */

}/* end of hra_urci_prvniho_hrace() */

/* -------------------------------------------------------------------------- */

/* Vrac slo hre, kter hru zanal */
GLOBAL unsigned char hra_dej_zacinal_hrac(void) {

    return(zacinal_hrac);

}/* end of hra_dej_zacinal_hrac() */

/* -------------------------------------------------------------------------- */

/* Nastav slo hre, kter hru zanal */
GLOBAL void hra_nastav_zacinal_hrac(int hrac) {

    zacinal_hrac = hrac;

}/* end of hra_nastav_zacinal_hrac() */

/* -------------------------------------------------------------------------- */

/* Vrt poad tahu, nen-li nastaven 'mid_wanted', co je pznak, e
 * nejsou dosud odehran dn kameny. Jinak vrt 1 */
GLOBAL int hra_dej_poradi_tahu(void) {
    
    return(turn);

}/* end of hra_dej_poradi_tahu() */

/* -------------------------------------------------------------------------- */

/* Vymn poad hr */
GLOBAL void hra_prepni_hrace(void) {

    player = (player == HRAC1) ? HRAC2 : HRAC1;
   
}/* end of hra_prepni_hrace() */
    
/* -------------------------------------------------------------------------- */

/* Nastav rack, board na poten hodnoty */
GLOBAL void hra_inicializuj(void) {
   
    static int count = 0;
    int x, y;
    char s1[MAX_ROZMER], s2[MAX_ROZMER];

    /* Prvn tah */
    turn = 1;
    
    /* Prvn odehrn kamen mus pokrt stedov polko, samotn
     * hodnota 'turn' nesta, nebo prvn me dojt k vmn => turn++ 
    */
    mid_wanted = TRUE;
    pass_count=0;
    skore_h1 = skore_h2 = 0;		/* dn skore zatm */
    sprintf(s1,"%d",skore_h1);
    sprintf(s2,"%d",skore_h2);
    hra_urci_prvniho_hrace();
    player = hra_dej_zacinal_hrac();
    game_mode = PLAY_MODE;    

    /* Optovn natn sady psmen je oeteno v modulu 'vacek' */
    nacti_sadu_kamenu(SADA_PISMEN);
   
    /* Potadlo natn kamen */ 
    count++;
   
    for (x=0; x<MAX_PISMEN_PRIHRADKA; x++) {
	rack_click[x] = FALSE;		         /* kmen nen oznaen ke he */
	rack_set_placed_on_board(x, FALSE)  ;/* kmen je v racku, ne na desce */
	rack_placed_tiles_coords[x].x = EMPTY_TILE; 
	/* x - nen umstn na desce = -1 */
	rack_placed_tiles_coords[x].y = EMPTY_TILE; 
	/* y - nen umstn na desce = -1 */
	rack_placed_tiles_coords[x].which = EMPTY_TILE;      
	/* dn psmeno z racku */
	
    }/* end for pro rack */

    /* Resetuj board - napl jej 'przdnm' mstem */
    for (x=0; x<MAX_ROZMER; x++)
	for (y=0; y<MAX_ROZMER; y++) {
	    board[x][y].znak = EMPTY_TILE;
	    board[x][y].hodnota = EMPTY_TILE;
	    score[x][y][ZD] = 0; score[x][y][SD] = 0;	/* dn skre */
	}

    /* Napln mnoinu cross na sam jedniky */
    cross_resetuj_struktury();

    /* Vyprzdni seznam generovanch tah */
    tahy_seznam_uvolni();
    gtk_clist_clear(GTK_CLIST(prubeh_clist));
    gtk_clist_clear(GTK_CLIST(pomoc_clist));
    
    /* Umonme zobrazen nalezench tah v oknku s tahy */
    set_help_handler_counter(EMPTY_TILE);

    /* Plnme pole [hvpo] */    
    prubeh_nastav_index(0);

    for(x=0;x<MAX_ROZMER;x++) { 

	/* Abychom pi generovn tah "nevyskoili" mimo desku */

	/* dek 0 pro HOR/VER */
	(cross[0][x])[0].lo = 0; (cross[0][x])[0].hi = 0;
        (cross[0][x])[1].lo = 0; (cross[0][x])[1].hi = 0;

	/* sloupec 0 pro HOR/VER */	
        (cross[x][0])[0].lo = 0; (cross[x][0])[0].hi = 0;
        (cross[x][0])[1].lo = 0; (cross[x][0])[1].hi = 0;
	
	/* sloupec SIRKA+1 pro HOR/VER */
        (cross[x][POC_KAMENU_SIRKA+1])[0].lo = 0; 
	(cross[x][POC_KAMENU_SIRKA+1])[0].hi = 0;
        (cross[x][POC_KAMENU_SIRKA+1])[1].lo = 0; 
	(cross[x][POC_KAMENU_SIRKA+1])[1].hi = 0;

	/* radek VYSKA+1 pro HOR/VER */
        (cross[POC_KAMENU_VYSKA+1][x])[0].lo = 0; 
	(cross[POC_KAMENU_VYSKA+1][x])[0].hi = 0;
        (cross[POC_KAMENU_VYSKA+1][x])[1].lo = 0; 
	(cross[POC_KAMENU_VYSKA+1][x])[1].hi = 0;

    }/* end for */

    /* Chceme vbec logovat? */
    if (logovat_prubeh & 1) {

	/* STD nem 1. bit nastaven */	
	if (logovat_prubeh == 1) 
	    logovani_nastav_std_nazev();

	printf("Vytvm log '%s'\n", LOGOVANI_SOUBOR);

	if (logovani_vytvor_soubor(LOGOVANI_SOUBOR, computer,player) == FALSE)
	    gui_logovani_chyba(GTK_WINDOW(app));

    }/* end if & 1 */

    board_set_tile_clicked(FALSE);               /* Pepna pro vbr kamene */

    /* Nastav text */
    gtk_frame_set_label(GTK_FRAME(pomoc_frame), "Pomoc");
    
    /* Tlatka mohou pijmat udlosti, hra zan */ 
    gtk_widget_set_sensitive(GTK_WIDGET(done_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(pass_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(change_button), TRUE);
    gtk_widget_set_sensitive(GTK_WIDGET(evaluate_button), TRUE);

    /* Nzvy jmen se ji mnit nesm, a nedochz ke zmatkm */
    gtk_entry_set_editable(GTK_ENTRY(player1_name), FALSE);
    gtk_entry_set_editable(GTK_ENTRY(player2_name), FALSE);
    
    /* Nastav skre a jmna hr na defaultn hodnoty */
    gtk_entry_set_text(GTK_ENTRY(player1_score), s1); 
    gtk_entry_set_text(GTK_ENTRY(player2_score), s2); 

    /* Checboxy pro vbr potae nesm fungovat */
    gtk_widget_set_sensitive(GTK_WIDGET(cbox1), FALSE);
    gtk_widget_set_sensitive(GTK_WIDGET(cbox2), FALSE);

    /* Vyisti board */
    for(x=0;x<POC_KAMENU_SIRKA;x++)
	for(y=0;y<POC_KAMENU_VYSKA;y++)
	    board_revert_tile_to_empty(x, y);

    if (player != computer)
	draw_rack();

    tahy_generuj_prvni_tah();

    strcpy(s1, "Zan hr: ");
    if (player == HRAC1) 
	strcat(s1, gtk_entry_get_text(GTK_ENTRY(player1_name))); 
    else
	strcat(s1, gtk_entry_get_text(GTK_ENTRY(player2_name))); 

    show_info_window(GTK_WINDOW(app), s1);

    /* Aktualizuj statusbar */
    gui_statusbar_zobraz_tah();
    gui_statusbar_zobraz_hrace();
    gui_statusbar_zobraz_zbytek();

    /* Je-li zanajc hr pota, prove tah */
    if (player == computer)
	hra_proved_hru_pocitace();
    

}/* end of hra_inicializuj() */

/* -------------------------------------------------------------------------- */
/* ------------------------------- NEW GAME --------------------------------- */
/* -------------------------------------------------------------------------- */

/* Zani novou hru */
GLOBAL void hra_nova_hra(void) {

    gui_slovniky_vyber_slovnik();
    hra_inicializuj();
    
}/* end of hra_nova_hra() */


/* -------------------------------------------------------------------------- */
/* ----------------------------- KONEC HRY ---------------------------------- */
/* -------------------------------------------------------------------------- */

/* Ukon hru, provede odpisy ze skre a aktualizuje max. skre
 * Parametr 'jak' uruje, zda se bude odepisovat vem (EMPTY_TILE)
 * anebo uruje hre (0/1), kter m przdn zsobnk. Tomuto hri
 * v tto situaci neodepisuj.
*/
LOCAL void hra_konec_hry(int jak) {
  
    char *hlaska = NULL;
    char *ukazatel = NULL;
    int lepsi_skore = 0;
    boolean remiza = FALSE;
    char hrac[MAX_ROZMER];
    char skore[10];
    char s1[MAX_ROZMER], s2[MAX_ROZMER];

    char stare_skore[10];
    char stary_hrac[MAX_ROZMER];

    /* Maximln skre */
    int max_skore;

    /* Zskej max. dosaen skre */
    gnome_config_push_prefix(SkorePrefix);
    max_skore = gnome_config_get_int("MAX_SKORE=0");
    ukazatel = gnome_config_get_string("MAX_SKORE_JMENO=Pan Tau");
    strcpy(stary_hrac, ukazatel);
    g_free((gpointer)ukazatel);
    gnome_config_pop_prefix();

    hra_proved_odpis(jak);

    sprintf(s1,"%d", skore_h1);
    sprintf(s2,"%d", skore_h2);

    /* Aktualizuj skre obou hr */
    gtk_entry_set_text(GTK_ENTRY(player1_score), s1); 
    gtk_entry_set_text(GTK_ENTRY(player2_score), s2); 

    /* Aktualizuj statusbar */
    gui_statusbar_zobraz_tah();
    gui_statusbar_zobraz_hrace();
    gui_statusbar_zobraz_zbytek();
    
    lepsi_skore = (skore_h1 <= skore_h2 ) ? skore_h2 : skore_h1;
    remiza = (skore_h1 == skore_h2) ? TRUE : FALSE;

    /* Zskej jmno hre, kter zvtzil */
    if (skore_h1 <= skore_h2)
	strcpy(hrac, gtk_entry_get_text(GTK_ENTRY(player2_name)));
    else
	strcpy(hrac, gtk_entry_get_text(GTK_ENTRY(player1_name)));
	
    
    /* Vypi jak skonila partie */
    if (remiza == TRUE) {
	hlaska = g_strconcat("KONEC HRY!\n-== Remza =--", NULL);
	show_info_window(GTK_WINDOW(app), hlaska);
    }
    else {
	hlaska = g_strconcat("KONEC HRY!\n",
			     "-== Zvtzil hr '", hrac, "' =--", NULL);
	show_info_window(GTK_WINDOW(app), hlaska);
    }
    
    g_free((gpointer) hlaska); hlaska = NULL;

    /* Insert coin :-) */
    if (lepsi_skore > max_skore) {

	sprintf(skore, "%d", lepsi_skore);
	sprintf(stare_skore, "%d", max_skore);
	
	hlaska = g_strconcat("Hr '", hrac, "' se ", skore, " body\n",
		             "pekonal zatm nejlep skre (",
			     stare_skore, " bod hre '", stary_hrac, 
			     "')!",  NULL);
	show_info_window(GTK_WINDOW(app), hlaska);

	gnome_config_push_prefix(SkorePrefix);
	gnome_config_set_int("MAX_SKORE", lepsi_skore);
	gnome_config_set_string("MAX_SKORE_JMENO", hrac);
	gnome_config_pop_prefix();
	gnome_config_sync();
    }/* end if ukldn skre */

    /* Zalogujeme vsledek */
    if (logovat_prubeh & 1)
	if (logovani_zapis_vysledek(skore_h1, skore_h2) == FALSE)
	    gui_logovani_chyba(GTK_WINDOW(app));

    g_free((gpointer) hlaska);

    game_mode = STOP_MODE;

    gui_okno_znehybni_widgety();

}/* end of hra_konec_hry() */

/* -------------------------------------------------------------------------- */
/* ----------------------------- UKONI HRU --------------------------------- */
/* -------------------------------------------------------------------------- */

/* Ukon hru, vymae ve, co jde, desku apod. */
GLOBAL void hra_ukonci_hru(void) {

    int x, y;

    /* Nic nedlej, pokud nic nehrajeme/nemnme */
    if (game_mode == STOP_MODE)
	return;

    /* Vyisti board */
    for(x=0;x<POC_KAMENU_SIRKA;x++)
        for(y=0;y<POC_KAMENU_VYSKA;y++)
     	    board_revert_tile_to_empty(y, x);

    rack_return_played_tiles_home();

    /* Piprav pdu pro vymazn psmen z racku */
    for(x=0;x<MAX_PISMEN_PRIHRADKA;x++) {
	rack1[x].znak = rack2[x].znak = EMPTY_TILE;
	rack1[x].hodnota = rack2[x].hodnota = EMPTY_TILE;
    }

    /* Przdn pihrdky */
    draw_rack();

    /* Skore na nule */
    gtk_entry_set_text(GTK_ENTRY(player1_score), "0");
    gtk_entry_set_text(GTK_ENTRY(player2_score), "0");
	    
    gui_okno_znehybni_widgety();

    /* Vyma seznamy tah */
    gtk_clist_clear(GTK_CLIST(prubeh_clist));
    gtk_clist_clear(GTK_CLIST(pomoc_clist));

    /* Nastav text */
    gtk_frame_set_label(GTK_FRAME(pomoc_frame), "Pomoc");
    
    /* Nastav "ekac" reim */
    game_mode = STOP_MODE;

    /* nastav slo tahu */
    mid_wanted = TRUE; turn = 1;
    
}/* end of hra_ukonci_hru */

/* -------------------------------------------------------------------------- */

/* Nastav odehran kameny, pepni hre, ... */
LOCAL void hra_aktualizuj_pocitadla(void) {
    
    int i;

    /* Po odehrn a nabrn novch kamen nemme nic na desce */ 
    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	rack_set_placed_on_board(i, FALSE);
	rack_placed_tiles_coords[i].which = EMPTY_TILE;
	rack_placed_tiles_coords[i].x = EMPTY_TILE;
	rack_placed_tiles_coords[i].y = EMPTY_TILE;
	rack_click[i] = FALSE;
    }

    turn++;
    hra_prepni_hrace();

}/* end of hra_aktualizuj_pocitadla() */

/* -------------------------------------------------------------------------- */

/* Prove hru pocitace + ve s tm spojen (verze hr = pota) 
 * Pota bude bu hrt kameny, nebo - pokud nen k dispozici dn
 * mon tah, provede zatm pass (bude umt i vmnu).
*/
GLOBAL void hra_proved_hru_pocitace(void) {

    boolean smer;
    int pocet_vymenenych = 0;
    int pocet_tahu = 0;
    

    /* Pro kadou obtnost (0/1/2) zde bude umstn
     * index do seznamu tah (poad - od nuly), kter se bude 
     * pro zvolenou rove hry vybrat k odehrn potaem.
    */
    int indexy_obtiznosti[3];
    
    int rozdeleni;

    int MISTR_INDEX = 0;
    int POKROCILY_INDEX = 0;
    int ZACATECNIK_INDEX = 0;

    pocet_tahu = tahy_seznam_dej_delku();

    /* Nejsou-li dostupn tahy, prove vzdn se tahu */
    /* !!!!Zatm!!!! */
    if (pocet_tahu == 0) {

	/* Nemme tahy - je to mon proto, e mme "patn"
	 * psmena v zsobnku. Pokusme se nkter vymnit.
	 * Pokud je ovem sek przdn, prove rovnou PASS.
	*/
	if (vacek_pocet_zbylych_kamenu() == 0) {
	    hra_proved_pass();
	    return;
	}
    
	if (vacek_pocet_zbylych_kamenu() > MAX_PISMEN_PRIHRADKA) {
	    /* Budeme hledat v zsobnku "nepotebn" ("xgf")
	     * psmena a ta vymnme. Poad se bere zleva doprava.
	    */
	    pocet_vymenenych = hra_proved_vymenu_pocitace();

		/* Ani jedno nepotebn nebylo nalezeno, prove
		 * PASS. Nen to chytr, ale nic lepho m nenapad.
		 * Mon by stlo za to otestovat zsobnk, zda se v nm
		 * nevyskytuje vt mnost stejnch psmen a ta vymnit.
		 * TODO.
		*/
		if (pocet_vymenenych == 0) 
		    hra_proved_pass();

		return;	/* Mme vymnno/PASSnuto */
		    
	}/* end if vacek_pocet_zbylych_kamenu > MAX_PISMEN_PRIHRADKA */
	
	else {	/* Mn ne MAX_PISMEN_PRIHRADKA, prove PASS */
	    hra_proved_pass();
	    return;
	}
	
    }/* end if pocet_tahu == 0 */
    
    /* Rozpotme indexy podle obtnosti */
    if (pocet_tahu == 2) {	/* 0,0,1 - Mistr,Pokroil,Zatenk */
	ZACATECNIK_INDEX = 1;
    }
    else if (pocet_tahu > 2) {

	rozdeleni = pocet_tahu/3;
	POKROCILY_INDEX = rozdeleni;
	ZACATECNIK_INDEX = 2*rozdeleni;
    }

    indexy_obtiznosti[0] = MISTR_INDEX;
    indexy_obtiznosti[1] = POKROCILY_INDEX;
    indexy_obtiznosti[2] = ZACATECNIK_INDEX;

    printf("POCET TAHU = %d, OBTIZNOST = %d, VYBRANO INDEX = %d\n",
	    pocet_tahu, obtiznost_hry, indexy_obtiznosti[obtiznost_hry]);

    /* Vyber tah podle obtnosti */    
    gui_ovladace_poloz_tah_pocitace(indexy_obtiznosti[obtiznost_hry]);

    if (move_is_placement_valid() != TRUE)
	show_warning_window(GTK_WINDOW(app),
		"Intern chyba programu (test umstn). " 
		"Prosm, nahlate vskyt tto chyby.");
    
    smer = (horizontal) ? HORIZONTAL : VERTICAL;
    
    if (tahy_is_move_valid(smer) != TRUE)
	show_warning_window(GTK_WINDOW(app),
		"Intern chyba programu (platnost tahu potae). "
	        " Prosm, nahlate vskyt tto chyby.");
   
    /* A prove regulrn tah */
    hra_proved_tah();
    
}/* end of hra_proved_hru_pocitace() */

/* -------------------------------------------------------------------------- */

/* Provede procedury potebn k vmn kamen pro pota.
 * Vrac 0  - nebylo nalezeno dn nepotebn psmeno
 *       >0 - poet vymnnch kamen
*/
LOCAL int hra_proved_vymenu_pocitace(void) {

    int i, j, kolik = 0;
    skamen *rack;
    int cetnosti[MAX_VEL_ABECEDY];

    /* Nejdve vyistme pole pro zaklikl psmena */
    for(j=0;j<MAX_PISMEN_PRIHRADKA;j++)
	rack_click[j] = FALSE;

    /* Projdi pes vechna nepotebn psmena. Ta jsou definovna
     * v hlavikovm souboru 'headers/globals.h' (UNWANTED).
     * Funkce rack_najdi_vyskyty_a_oznac() najde v pihrdce
     * dan psmeno a na danm indexu v rack_click[] nastav
     * poloku na TRUE (=vymnit).
    */
    for(i=0;i<UNWANTED_DELKA;i++)
	rack_najdi_vyskyty_a_oznac(UNWANTED[i]);
   
    /* Te zjistme, jestli jsme nco "nepotebnho" v
     * pihrdce nenali. Jestlie ne, vrac se 0. 
    */

    /* Hledme v tom sprvnm */
    rack = (player == HRAC1) ? rack1 : rack2;

    for (i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack_click[i]) {
	    printf("Vmna psmen potae: mnme '%c'\n", rack[i].znak);
	    kolik++;
	}

    /* Nenali jsme dn nepotebn, pokusme se vymnit
     * duplicitn psmena (ne ovem olky). Nejprve vytvome
     * pihrdku, ve kter budou jen etnosti vech psmen z pihrdky.
    */
    if (!kolik) {
	
	/* Naplnme rack 'nulami' */
	for(i=0;i<MAX_VEL_ABECEDY;i++)
	    cetnosti[i] = 0;

        /* Zvy potadlo vskyt pro kad psmeno z pihrdky */
	    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
		if ((j=rack[i].znak) != EMPTY_TILE) 
		    cetnosti[znak2index(j)]++;
	    
	/* Projdeme celou abecedu a pokud je etnost psmene v pihrdce
	 * aspo 2, tak jedno takov psmeno vymnme. Nemnit ovem olka!
	*/
	for(i=0;i<MAX_VEL_ABECEDY-1;i++)   /* -1 = abych neprochzel olka */
	    if (cetnosti[i] > 1) {
		printf("Vmna potae (duplicita) '%c'\n", index2znak(i));
		if ( (rack_najdi_jeden_a_oznac(index2znak(i))) == FALSE )
		    fprintf(stderr, 
			"Intern chyba (hra.c): "
			"hra_proved_vymenu_pocitace()\n");
	    }/* cetnosti[i] > 1 */
    
	/* Zkontrolujeme, zda jsme njak duplicitn psmena nali
	 * (= nkter poloka rack_click[] je TRUE)
	*/ 
	kolik = 0;
	for (i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack_click[i]) {
		printf("Nalezeny duplicity: psmeno '%c'\n", rack[i].znak);
		kolik++;
	    }

	/* Te u opravdu nen co mnit, ukonme to trpen :-) */
	if (!kolik)
	    return(0);

    }/* end if (!kolik) */
   
	    
    /* Zavolej modul 'vacek' pro vmnu kamen a zjisti, kolik
     * bylo vymnno kamen.
    */
    i = vacek_vymen_kameny(player);

    /* Aktualizuj okno s prbhem hry */
    zapis_tah_do_tabulky(TAH_VYMENA_KAMENU, i);

    hra_aktualizuj_pocitadla();

    pass_count=0;			/* Potme po sob jdouc */

    /* Hrajeme-li proti potai, pi jeho tahu nesm
     * bt vidt jeho pihrdka.
    */
    if (computer != player)
	draw_rack();

    /* Aktualizuj statusbar */
    gui_statusbar_zobraz_tah();
    gui_statusbar_zobraz_hrace();
    gui_statusbar_zobraz_zbytek();

    if (mid_wanted == TRUE)
	tahy_generuj_prvni_tah();
    else
	tahy_generuj_tah();

    return(i);

}/* end of hra_proved_vymenu_pocitace() */

/* -------------------------------------------------------------------------- */

/* Prove odehran kamen + ve s tm spojen (verze hr = lovk) */
GLOBAL void hra_proved_tah(void) {

    int i, j;
    char s1[MAX_ROZMER], s2[MAX_ROZMER];
 
    for(i=1;i<=POC_KAMENU_SIRKA;i++) {
	for(j=1;j<=POC_KAMENU_VYSKA;j++)
	    printf("%c", 
		    (board[i][j].znak != EMPTY_TILE) ? board[i][j].znak : '0');
	putchar('\n');
    }
    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	printf("%d@[%d,%d],",i,rack_placed_tiles_coords[i].x,
		               rack_placed_tiles_coords[i].y);
    putchar('\n');

    board_set_placed_tiles_color();	/* Odehran budou oznaeny na blo */

    zapis_tah_do_tabulky(TAH_ODEHRANI_KAMENU, 0);
    
    sprintf(s1,"%d", skore_h1);
    sprintf(s2,"%d", skore_h2);

    /* Aktualizuj skre obou hr */
    gtk_entry_set_text(GTK_ENTRY(player1_score), s1); 
    gtk_entry_set_text(GTK_ENTRY(player2_score), s2); 

    /* Spotej cross-set mnoiny */ 
    aktualizuj_cross_set((horizontal == TRUE) ? HORIZONTAL : VERTICAL);	

    /* nen nutn ji umsovat na sted */
    mid_wanted = FALSE; 

    for(i=0; i<MAX_PISMEN_PRIHRADKA; i++)
        printf("[%d],", rack_placed_tiles_coords[i].which);
    putchar('\n');

    i = vacek_hrej_kameny(player);	/* Nati do pihrdky nov kameny */
    if (i==0)
	show_warning_window(GTK_WINDOW(app),
		"Intern chyba (vacek_hrej_kameny == 0)!");
    
	
   
    /* Przdn pihrdka jednoho z hr == KONEC HRY! */
    if (rack_is_empty(player) == TRUE) {
	show_info_window(GTK_WINDOW(app), WARN_NO_TILES_IN_RACK);
	hra_konec_hry(player);
	return;
    }
    else {

	hra_aktualizuj_pocitadla();	/* Zvy tah, vym hre, vykresli... */

	pass_count=0;			/* Potme po sob jdouc passy */

	/* Hrajeme-li proti potai, pi jeho tahu nesm
	 * bt vidt jeho pihrdka.
	*/
	if (computer != player)
	    draw_rack();

	/* Aktualizuj statusbar */
	gui_statusbar_zobraz_tah();
	gui_statusbar_zobraz_hrace();
	gui_statusbar_zobraz_zbytek();

	tahy_generuj_tah();

    }/* end else */
    
}/* end of hra_proved_tah() */

/* -------------------------------------------------------------------------- */

/* Provede procedury potebn k vmn kamen */
GLOBAL void hra_proved_vymenu(void) {

    int i, j;
    char hlaska[DMAX] = "";
    char kolik[5] = "";

    /* Zavolej modul 'vacek' pro vmnu kamen a zjisti, kolik
     * bylo vymnno kamen.
    */
    i = vacek_vymen_kameny(player);

    /* Nelze-li nic vymnit, nem tah cenu */
    if (i == FALSE) {
	show_warning_window(GTK_WINDOW(app), 
		"Ve vku nejsou ji pro vmnu kameny!");
	
	for(j=0;j<MAX_PISMEN_PRIHRADKA;j++)
	    rack_click[j] = FALSE;

	/* troka prasrny */
	game_mode = PLAY_MODE;
	rack_return_played_tiles_home();
	game_mode = CHANGE_MODE;
	return;
    }

    /* Informuj, e se nevymnili vechny poadovan kameny */
    if (i != rack_how_many_exchange()) {
	strcpy(hlaska, "Nedostatek kamen ve vku pro vmnu vech\n"
		"poadovanch kamen. Probhla vmna jen ");
	sprintf(kolik, "%d", i);
	strcat(hlaska, kolik);
	strcat(hlaska, " kamen.");
	show_info_window(GTK_WINDOW(app), hlaska);
    }

    /* Aktualizuj okno s prbhem hry */
    zapis_tah_do_tabulky(TAH_VYMENA_KAMENU, i);

    hra_aktualizuj_pocitadla();

    pass_count=0;			/* Potme po sob jdouc */

    /* Hrajeme-li proti potai, pi jeho tahu nesm
     * bt vidt jeho pihrdka.
    */
    if (computer != player)
	draw_rack();

    /* Aktualizuj statusbar */
    gui_statusbar_zobraz_tah();
    gui_statusbar_zobraz_hrace();
    gui_statusbar_zobraz_zbytek();

    if (mid_wanted == TRUE)
	tahy_generuj_prvni_tah();
    else
	tahy_generuj_tah();

}/* end of hra_proved_vymenu() */

/* -------------------------------------------------------------------------- */

/* Provede PASS (vzdn se tahu. Nen poteba potat skore, ani
 * nic podobnho, jen zapsat do tabulky tah, e lo o PASS a zvit
 * potadlo tah... 
*/
GLOBAL void hra_proved_pass(void) {

    zapis_tah_do_tabulky(TAH_PROVEDEN_PASS, 0);	/* Aktualizuj prbh hry */
    
    hra_aktualizuj_pocitadla();		/* Zvy tah, vym hre, vykresli... */

    pass_count++;			/* Potme po sob jdouc */


    /* Po 4 PASSech po sob hra kon */
    if (pass_count == 4) {
	show_info_window(GTK_WINDOW(app), INFO_FOUR_PASSES);
	hra_konec_hry(EMPTY_TILE);
	return;
    }
    else {
	
	/* Hrajeme-li proti potai, pi jeho tahu nesm
	 * bt vidt jeho pihrdka.
	*/
	if (computer != player)
	    draw_rack();

	/* Aktualizuj statusbar */
	gui_statusbar_zobraz_tah();
        gui_statusbar_zobraz_hrace();
	gui_statusbar_zobraz_zbytek();

	if (mid_wanted == TRUE)
	    tahy_generuj_prvni_tah();
	else
	    tahy_generuj_tah();
    }

}/* end of hra_proved_pass() */
    

/* -------------------------------------------------------------------------- */

/* Provede odpis (vzdn se tahu. Nen poteba potat skore, ani
 * nic podobnho, jen zapsat do tabulky tah, e lo o PASS a zvit
 * potadlo tah... 
*/
LOCAL void hra_proved_odpis(int komu) {

    int i, suma;
    skamen *rack;
    int o1, o2;

    o1 = o2 = 0; /* Kolik pipsat/odepsat hrm 1,2 */

    /* 4x PASS, odepisujeme vem */
    if (komu == EMPTY_TILE) {
	suma = 0;
	for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack1[i].znak != EMPTY_TILE)
		suma += rack1[i].hodnota;
	
	o1 = -suma; /* Odeet pro hre 1 */
	printf("Hri 1 proveden odeet %d bod\n", suma);

	suma = 0;
	for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack2[i].znak != EMPTY_TILE)
		suma += rack2[i].hodnota;

	o2 = -suma; /* Odeet pro hre 1 */
	printf("Hri 2 proveden odeet %d bod\n", suma);

	/* Sprvn poad odpisu! */
	if (player == HRAC1) {
	    zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, o1);
	    hra_aktualizuj_pocitadla();
	    zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, o2);
	    hra_aktualizuj_pocitadla();
	}
	else {
	    zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, o2);
	    hra_aktualizuj_pocitadla();
	    zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, o1);
	    hra_aktualizuj_pocitadla();
	}
	
    }/* end if 4x PASS */
    else {
    /* Dolo k vyprzdnn zsobnku jednoho hre, podle pravidel se odepisuje
     * druhmu hri ze skre hodnota kamenu v zsobnku a tato hodnota se
     * navc pite hri s przdnm zsobnkem.
    */
	/* Je to opan ne ve zbytku kdu - pozor! upisujeme! */
	rack = (komu == HRAC1) ? rack2 : rack1;
	suma = 0;
	for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack[i].znak != EMPTY_TILE)
		suma += rack[i].hodnota;

	if (komu == HRAC1) {
	    o1 = suma;
	    o2 = -suma;
	    printf("XHri 1 se pipisuje %d bod\n", suma);
	    printf("XHri 2 se odepisuje %d bod\n", suma);
	}
	else {
	    o1 = -suma;
	    o2 = suma;
	    printf("XHri 1 se odepisuje %d bod\n", suma);
	    printf("XHri 2 se pipisuje %d bod\n", suma);
	}

	zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, suma);
	hra_aktualizuj_pocitadla();
	zapis_tah_do_tabulky(TAH_PROVEDEN_ODPIS, -suma);
	hra_aktualizuj_pocitadla();

    }/* end else */

    /* Men finta, chci aktualizovat skre a po zalogovn,
     * proto toto.
    */
    skore_h1 += o1;
    skore_h2 += o2;

}/* end of hra_proved_odpis() */

/* -------------------------------------------------------------------------- */

/* Nastav povol_cheat na 'stav' */
GLOBAL void hra_nastav_podvadeni(boolean stav) {

    povol_cheat = stav;
    
}/* end of hra_nastav_podvadeni() */

/* -------------------------------------------------------------------------- */

/* Vrac stav 'povol_cheat' */
GLOBAL boolean hra_dej_stav_podvadeni(void) {

    return(povol_cheat);
    
}/* end of hra_dej_stav_podvadeni() */

/* -------------------------------------------------------------------------- */
    
/* END_OF_FILE hra.c */
