#include<stdio.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "config.h"
#include "cross.h"
#include "vacek.h"
#include "deska.h"
#include "prihradka.h"
#include "hra.h"
#include "konverze.h"

#define	TRUE		1
#define FALSE		0

/* --------------------- DEFINICE GLOBALNCH PROMNNCH --------------------- */

GLOBAL skamen rack1[MAX_ROZMER];    /* skamen = znak, hodnota, x, y */
GLOBAL skamen rack2[MAX_ROZMER];    /* skamen = znak, hodnota, x, y */

GLOBAL int rack_click[MAX_ROZMER];        /* Pro vmnu kamen */
GLOBAL ssouradnice rack_placed_tiles_coords[MAX_ROZMER];
/* Kter pole z racku ji na desce */
GLOBAL boolean rack_placed_on_board[MAX_ROZMER];   
/* --------------------- DEFINICE LOCALNCH PROMNNCH ---------------------- */

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL int rack_how_many_exchange(void);
GLOBAL int rack_is_empty(int hrac);
GLOBAL boolean rack_is_something_placed(void);
GLOBAL boolean rack_is_any_tile_clicked(void);
GLOBAL boolean rack_is_placed_on_board(int what);
GLOBAL boolean rack_is_it_currently_played_tile(int x, int y);
GLOBAL void rack_unclick(int what);
GLOBAL void rack_set_placed_on_board(int what, boolean status);
GLOBAL void rack_set_placed_tiles_coords(int what, int x, int y, int which);
GLOBAL int rack_game_what_clicked(void);
GLOBAL int rack_which_tile_at_coords(int x, int y);
GLOBAL int rack_najdi_vyskyt(unsigned char index);
GLOBAL void rack_najdi_vyskyty_a_oznac(char znak);
GLOBAL boolean rack_najdi_jeden_a_oznac(char znak);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

/* -------------------------------------------------------------------------- */
/*			  DEFINICE JEDNOTLIVCH FUNKC                        */
/* -------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------- */

/* Po umstn kamene na desku ulo jeho pozici pro ppadn pesun */
GLOBAL void rack_set_placed_tiles_coords(int what, int x, int y, int which) {

    rack_placed_tiles_coords[what].x = y;
    rack_placed_tiles_coords[what].y = x;
    rack_placed_tiles_coords[what].which = which;
}

/* -------------------------------------------------------------------------- */

/* Nastav kamenu z racku status TRUE/FALSE = umstn/neumstn na desce */
GLOBAL void rack_set_placed_on_board(int what, boolean status) {

    rack_placed_on_board[what] = status;
}

/* -------------------------------------------------------------------------- */

/* Najde v pihrdce prvn vskyt znaku. Ten je reprezentovan
 * indexem do abecedy, ppadn i s JOKERBITEM */
GLOBAL int rack_najdi_vyskyt(unsigned char index) {

    skamen *rack;
    int i;
    char znak;
    
    znak = index2znak(index & ~JOKERBIT);

    rack = (player == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

    /* Hled se NEolkov vskyt */
    if (!(index & JOKERBIT)) {
	for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack[i].znak != EMPTY_TILE)
		if ( (rack_is_placed_on_board(i)) == FALSE )
		    if (rack[i].znak == znak)
			return(i);
    }/* end if NEolkov */

    /* Nenali jsme mezi psmeny, najdi prvn '?' (=olk) */
    if ((index & JOKERBIT)) {
	for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	    if (rack[i].znak != EMPTY_TILE)
		if ( (rack_is_placed_on_board(i)) == FALSE )
		    if (rack[i].znak == JOKERCHAR)
			return(i);
	
    }/* end if olkov */
    
    fprintf(stderr, "Upozornn: (prihradka.c): Nenalezen znak v pihrdce\n");

    return(EMPTY_TILE);

}/* end of rack_najdi_vyskyt() */

/* -------------------------------------------------------------------------- */

/* Funkce projde pihrdku hre a ozna v poli rack_click[] 
 * vechny pozice, na kterch se 'znak' v pihrdce vyskytuje.
*/
GLOBAL void rack_najdi_vyskyty_a_oznac(char znak) {

    int i;
    skamen *rack;

    /* Hledme v tom sprvnm */
    rack = (player == HRAC1) ? rack1 : rack2;

    for(i=0; i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack[i].znak != EMPTY_TILE)
	    if (rack[i].znak == znak)
		rack_click[i] = TRUE;
    
}/* end of rack_najdi_vyskyty_a_oznac() */

/* -------------------------------------------------------------------------- */

/* Najde prvn pozici znaku v pihrdce a tu ozna
 * v rack_click[]. Pokud dojde k njak intern chyb
 * ('znak' by ml bt vdy nalezen), vrac se FALSE,
 * jinak TRUE.
*/
GLOBAL boolean rack_najdi_jeden_a_oznac(char znak) {
    
    int i;
    skamen *rack;

    /* Hledme v tom sprvnm */
    rack = (player == HRAC1) ? rack1 : rack2;

    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if (rack[i].znak != EMPTY_TILE)
	    if (rack[i].znak == znak) {
		rack_click[i] = TRUE;
		return(TRUE);
	    }

    return(FALSE);
    
}/* end of rack_najdi_jeden_a_oznac() */

/* -------------------------------------------------------------------------- */

/* Vrac index psmene z racku, kter se nachz na desce na [x,y] */
/* Pi chyb/nenalezen vrac -1 */
GLOBAL int rack_which_tile_at_coords(int x, int y) {
    
    int i;

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++) {
	if ((rack_placed_tiles_coords[i].x == x) && 
	    (rack_placed_tiles_coords[i].y == y))
	    return(rack_placed_tiles_coords[i].which);
    }
	
    return(EMPTY_TILE);
    
}/* end of rack_placed_tiles_coords() */

/* -------------------------------------------------------------------------- */

/* Vrac TRUE, je-li oznaeno nkter psmeno v racku */
GLOBAL boolean rack_is_any_tile_clicked(void) {

    int x;

    for (x=0; x<MAX_PISMEN_PRIHRADKA; x++)
	if (rack_click[x] == TRUE)
	    return(TRUE);
    
    return(FALSE);
}

/* -------------------------------------------------------------------------- */

/* Vrac TRUE/FALSE, pokud je rack hre przdn */
GLOBAL boolean rack_is_empty(int hrac) {

    skamen *rack;
    int i;

    rack = (hrac == HRAC1) ? rack1 : rack2; /* Nastav sprvn rack */

    for(i=0;i<MAX_PISMEN_PRIHRADKA;i++)
	if(rack[i].znak != EMPTY_TILE)
	    return(FALSE);

    return(TRUE);

}/* end of rack_is_empty() */

/* -------------------------------------------------------------------------- */

/* Vrac poet kamen oznaench pro vmnu */
GLOBAL int rack_how_many_exchange(void) {

    int kolik = 0;
    int i;

    for(i=0; i<MAX_PISMEN_PRIHRADKA; i++)
       if (rack_click[i] == TRUE)
           kolik++;

    return(kolik);
}

/* -------------------------------------------------------------------------- */

/* Odzna oznaen kmen pro hru/vmnu */
GLOBAL void rack_unclick(int what) {
    
    rack_click[what] = FALSE;

}

/* -------------------------------------------------------------------------- */

/* Vrac TRUE, pokud byl kmen pesunut na desku */
GLOBAL boolean rack_is_placed_on_board(int what) {

    return(rack_placed_on_board[what]);
}

/* -------------------------------------------------------------------------- */

/* Vrac TRUE, pokud je z racku na boardu umstn aspo jeden kmen */
GLOBAL boolean rack_is_something_placed(void) {

    int i;

    for (i=0; i<MAX_PISMEN_PRIHRADKA; i++)
	if (rack_placed_tiles_coords[i].which != EMPTY_TILE)
	    return(TRUE);

    return(FALSE);
    
}
/* -------------------------------------------------------------------------- */

/* Zkontroluje, zda se na zadanch souadnicch nachz prv
 * odehrvan kmen
*/
GLOBAL boolean rack_is_it_currently_played_tile(int x, int y) {
    
    if (rack_which_tile_at_coords(x, y) == EMPTY_TILE)
	return(FALSE);

    return(TRUE);
}

/* -------------------------------------------------------------------------- */

/* Vrac index 0-6 oznaenho psmene v racku */
GLOBAL int rack_game_what_clicked(void)
{
    int x;

    for (x=0; x<MAX_PISMEN_PRIHRADKA; x++)
        if (rack_click[x] == TRUE)
            return(x);

    return(EMPTY_TILE);
}


/* -------------------------------------------------------------------------- */

/* END_OF_FILE prihradka.c */
