#include<glib.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "cross.h"
#include "vacek.h"
#include "tahy_seznam.h"
#include "konverze.h"

/* ------------------------ DEFINICE LOCALNCH TYP ------------------------- */

/* --------------------- DEKLARACE GLOBALNCH PROMNNCH -------------------- */

/* --------------------- DEKLARACE LOCALNCH PROMNNCH --------------------- */

LOCAL GSList *seznam = NULL;
LOCAL gint seznam_delka;

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void tahy_seznam_pridej(Tah *tah);
GLOBAL void tahy_seznam_uvolni(void);
GLOBAL void tahy_seznam_vypis_seznam(void);
GLOBAL int  tahy_seznam_dej_delku(void);
GLOBAL Tah tahy_seznam_dej_polozku(int i);

/* ---------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL gint f_porovnej(gconstpointer a, gconstpointer b);

/* ----------------------- DEFINICE GLOBALNCH FUNKC ----------------------- */

/* Pid do seznamu tah dal poloku */
GLOBAL void tahy_seznam_pridej(Tah *tah) {
  
    Tah *ptah;

    /* Musme vytvoit novou poloku */
    if ( (ptah = (Tah *) malloc(sizeof(Tah))) == NULL ) {
	fprintf(stderr, "FATAL (tahy_seznam.c) - malloc == NULL!\n");
	exit(EXIT_FAILURE);
    }

    /* Zkoprujeme narz vechny atributy */
    memcpy( (void *) ptah, (void *) tah, sizeof(Tah));

    /* Prove pidn do seznamu (zati podle skre) */
    seznam = g_slist_insert_sorted(
	     seznam, (gpointer) ptah, (GCompareFunc) f_porovnej);

    seznam_delka = g_slist_length(seznam);
   
}/* end of tahy_seznam_pridej() */

/* -------------------------------------------------------------------------- */

/* Uvoln pam po seznamu */
GLOBAL void tahy_seznam_uvolni(void) {

    GSList *iterator;

    iterator = seznam;

    /* Toto mus bt, jinak zahltme vechno! */
    while(iterator) {
	g_free(iterator->data);
	iterator = iterator->next;
    }
    
    if (seznam)
	g_slist_free(seznam);

    seznam = NULL;

    seznam_delka = 0;

}/* end of tahy_seznam_uvolni() */

/* -------------------------------------------------------------------------- */

/* Pouzdc funkce pro zskn aktuln dlky seznamu */
GLOBAL int tahy_seznam_dej_delku(void) {

    return( (int) seznam_delka);
}

/* -------------------------------------------------------------------------- */

/* Vra 'i'-tou poloku seznamu (tou je 1 tah), pokud je 'i'
 * vt ne dlka seznamu, vra NULL.
*/
GLOBAL Tah tahy_seznam_dej_polozku(int i) {

    Tah *t; 
   
    t = (Tah *) g_slist_nth_data(seznam, i);

    return(*t);

}/* end of tahy_seznam_dej_polozku() */

/* -------------------------------------------------------------------------- */

/* Pro ilustraci - vpis seznamu */
GLOBAL void tahy_seznam_vypis_seznam(void) {

    int i, j;
    Tah *t;

    for(i=0;i<seznam_delka;i++) {
	
	t = (Tah *) g_slist_nth_data(seznam, i);
	fprintf(stderr, "------------------------------------\n");
	fprintf(stderr, "Skore[%d] = %d\n", i, t->skore);
	fprintf(stderr, "MostLeft = [%d,%d,%s]\n", 
		t->p.x, t->p.y, (t->o == ZD) ? "Horizontal" : "Vertical");

	fprintf(stderr, "Word = ");
	for(j=0;j<t->slen;j++)
	    fprintf(stderr,"%c", t->s[j]);
	fprintf(stderr,"\nUsed tiles = ");

	for(j=0;j<t->klen;j++)
	    fprintf(stderr, "([%d,%d,%c,%d])", 
		t->k[j].x, t->k[j].y, index2znak(t->k[j].z & ~JOKERBIT), t->k[j].h);
	fprintf(stderr, "\n");

    }/* end for */

    
}/* end of tahy_seznam_vypis_seznam() */

/* ---------------------- DEFINICE LOCALNCH FUNKC ------------------------- */

/* Porovnvac funkce pro g_slist_insert_sorted().
 * Vrac:  0 <=> a==b
 *        -1 <=> a > b
 *	  +1 <=> a < b
*/
LOCAL gint f_porovnej(gconstpointer a, gconstpointer b) {

    Tah *c;
    Tah *d;

    c = (Tah *) a;
    d = (Tah *) b;

    if (c->skore < d->skore)
        return(1);
    if (c->skore == d->skore)
        return(0);
    else
        return(-1);

}/* end of f_porovnej() */


/* -------------------------------------------------------------------------- */

/* END_OF_FILE tahy_seznam.c */
