#include<stdio.h>
#include<stdlib.h>
#include<glib.h>
#include<string.h>
#include "headers/stddfn.h"
#include "headers/globals.h"
#include "cesty.h"

/* ------------------------ DEFINICE LOCALNCH TYP ------------------------- */

/* --------------------- DEKLARACE GLOBALNCH PROMNNCH -------------------- */

/* --------------------- DEKLARACE LOCALNCH PROMNNCH --------------------- */

LOCAL GHashTable *hash_tabulka = NULL;
LOCAL GHashTable *ajka_hash_tabulka = NULL;

/* --------------- PLN FUNKN PROTOTYPY GLOBALNCH FUNKC ---------------- */

GLOBAL void vyznamy_nacti_soubor(void);
GLOBAL void vyznamy_ajka_nacti_soubor(void);
GLOBAL void vyznamy_ukonci_praci(void);
GLOBAL void vyznamy_ajka_ukonci_praci(void);
GLOBAL char* vyznamy_dej_vyznam(char *slovo);
GLOBAL char* vyznamy_ajka_dej_vyznam(char *znacka);

/* --------------- PLN FUNKN PROTOTYPY LOCALNCH FUNKC ---------------- */

LOCAL gboolean hash_odstran_polozku(gpointer klic, 
				    gpointer hodnota, 
				    gpointer data); 

/* -------------------- DEFINICE JEDNOTLIVCH FUNKC ------------------------ */

/* Funkce je potebn pro odstrann vech poloek z hash tabulky */
LOCAL 
gboolean hash_odstran_polozku(gpointer klic, gpointer hodnota, gpointer data) {

    return(TRUE);

}/* end of vyznamy_hash_odstran_polozku() */

/* -------------------------------------------------------------------------- */

/* Funkce nate soubor do hash tabulky */
GLOBAL void vyznamy_nacti_soubor(void) {

    FILE *soubor; 
    
    int i, j;
    char *leva = NULL;
    char *prava = NULL;
    char lleva[100];
    char pprava[1024];
    char radek[1024];

    /* Bez vklad ani rnu */
    if ((soubor = fopen(KRI_VYKLADOVY_CESTA, "r")) == NULL) {
        fprintf(stderr, "Soubor s vklady '%s' nenalezen!\n",  
		KRI_VYKLADOVY_CESTA);
        exit(-1);
    }

    /* Vytvome vlastn hash tabulku */
    hash_tabulka = g_hash_table_new( (GHashFunc) g_str_hash, 
				     (GCompareFunc) g_str_equal);


    /* A nasypeme do n vechny vznamy */
    while ( (fgets(radek, 1023, soubor)) != NULL ) {

	/* Nutno dek 'SLOVO@VZNAM' rozsekat */
	i = 0;
	while(radek[i] != '@')
	   lleva[i] = radek[i++]; 
	lleva[i++] = '\0';
	
	j = 0;
	while(radek[i] != '\n') 
	   pprava[j++] = radek[i++]; 
	pprava[j] = '\0';	

	/* Toto je hint pro ueten pamti, alokujeme jen kolik je
	 * poteba, i kdy to pot stoj voln 'strcpy'.
	*/
	if ( (leva=(char *) malloc(strlen(lleva)+10)) == NULL ) {
	    fprintf(stderr, "vyznamy.c malloc1 selhal!\n");
	    exit(-1);
	}
	strcpy(leva, lleva);

	if ( (prava=(char *) malloc(strlen(pprava)+10)) == NULL ) {
	    fprintf(stderr, "vyznamy.c malloc2 selhal\n");
	    exit(-1);
	}
	strcpy(prava, pprava);

	/* Naper to tam! */
	g_hash_table_insert(hash_tabulka, (gpointer) leva, (gpointer) prava);
		
    }/* end while */

    fclose(soubor);

}/* end of vyznamy_nacti_soubor() */

/* -------------------------------------------------------------------------- */

/* Funkce nate soubor s dvojicemi znaek do ajka_hash_tabulky */
GLOBAL void vyznamy_ajka_nacti_soubor(void) {

    FILE *soubor; 
    
    int i, j;
    char *leva = NULL;
    char *prava = NULL;
    char lleva[5];
    char pprava[50];
    char radek[100];

    /* Bez vklad ani rnu */
    if ((soubor = fopen(AJKA_DVOJICE_CESTA, "r")) == NULL) {
        fprintf(stderr, "Soubor s vklady znaek ajky '%s' nenalezen!\n",  
		AJKA_DVOJICE_CESTA);
        exit(-1);
    }

    /* Vytvome vlastn hash tabulku */
    ajka_hash_tabulka = g_hash_table_new( (GHashFunc) g_str_hash, 
		        (GCompareFunc) g_str_equal);


    /* A nasypeme do n vechny dvojice  */
    while ( (fgets(radek, 90, soubor)) != NULL ) {

	/* Nutno dek 'XX#VZNAM' rozsekat */
	i = 0;
	while(radek[i] != '#')
	   lleva[i] = radek[i++]; 
	lleva[i++] = '\0';
	
	j = 0;
	while(radek[i] != '#') 
	   pprava[j++] = radek[i++]; 
	pprava[j] = '\0';	

	/* Toto je hint pro ueten pamti, alokujeme jen kolik je
	 * poteba, i kdy to pot stoj voln 'strcpy'.
	*/
	if ( (leva=(char *) malloc(strlen(lleva)+10)) == NULL ) {
	    fprintf(stderr, "vyznamy.c ajka malloc1 selhal!\n");
	    exit(-1);
	}
	strcpy(leva, lleva);

	if ( (prava=(char *) malloc(strlen(pprava)+10)) == NULL ) {
	    fprintf(stderr, "vyznamy.c ajka malloc2 selhal\n");
	    exit(-1);
	}
	strcpy(prava, pprava);

	/* Naper to tam! */
	g_hash_table_insert(ajka_hash_tabulka, (gpointer) leva, (gpointer) prava);
		
    }/* end while */

    fclose(soubor);

}/* end of vyznamy_ajka_nacti_soubor() */

/* -------------------------------------------------------------------------- */

/* Uvolnme po sob pam */
GLOBAL void vyznamy_ukonci_praci(void) {
    
    g_hash_table_foreach_remove(hash_tabulka, 
                                (GHRFunc) hash_odstran_polozku, NULL);

    g_hash_table_destroy(hash_tabulka);

    hash_tabulka = NULL;
    
}/* end of vyznamy_ukonci_praci() */

/* -------------------------------------------------------------------------- */

/* Uvolnme po sob pam */
GLOBAL void vyznamy_ajka_ukonci_praci(void) {
    
    g_hash_table_foreach_remove(ajka_hash_tabulka, 
                                (GHRFunc) hash_odstran_polozku, NULL);

    g_hash_table_destroy(ajka_hash_tabulka);

    ajka_hash_tabulka = NULL;
    
}/* end of vyznamy_ajka_ukonci_praci() */

/* -------------------------------------------------------------------------- */

/* Vrac ukazatel na etzec s vznamem anebo NULL, pokud vznam slova
 * nen nalezen.
*/
GLOBAL char* vyznamy_dej_vyznam(char *slovo) {

    gpointer vyznam = NULL;

    if ( (vyznam = g_hash_table_lookup(hash_tabulka, 
			(gconstpointer) slovo)) == NULL)
	return(NULL);
    else
	return((char *) vyznam);

}/* end of vyznamy_dej_vyznam() */

/* -------------------------------------------------------------------------- */

/* Vrac ukazatel na etzec s vznamem anebo NULL, pokud vznam znaky
 * ajky nen nalezen.
*/
GLOBAL char* vyznamy_ajka_dej_vyznam(char *znacka) {

    gpointer vyznam = NULL;

    if ( (vyznam = g_hash_table_lookup(ajka_hash_tabulka, 
			(gconstpointer) znacka)) == NULL)
	return(NULL);
    else
	return((char *) vyznam);

}/* end of vyznamy_ajka_dej_vyznam() */

/* -------------------------------------------------------------------------- */

/* END_OF_FILE vyznamy.c */
